// BmpFileViewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BmpFileView.h"
#include "BmpFileViewDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmpFileViewDlg dialog

CBmpFileViewDlg::CBmpFileViewDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBmpFileViewDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBmpFileViewDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBmpFileViewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBmpFileViewDlg)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_TB_MSG, m_Edit);
}

BEGIN_MESSAGE_MAP(CBmpFileViewDlg, CDialog)
	//{{AFX_MSG_MAP(CBmpFileViewDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_OPENIMAGE, OnOpenimage)
	ON_COMMAND(IDM_ABOUT, OnAbout)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmpFileViewDlg message handlers

BOOL CBmpFileViewDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	this->m_pBmp = NULL;
	this->m_pIco = NULL;
	this->m_pPe = NULL;
	this->m_pPsd = NULL;

	m_wndMyTreeList.SubclassDlgItem(IDC_TREELIST1, this);
	CTreeListCtrl& m_tree = this->m_wndMyTreeList.m_tree;

	m_tree.SetBkColor(RGB(0xff, 0xff, 0xff));
	m_tree.SetGridLines(TRUE);
	//ǷԵheader
	//m_tree.m_wndHeader.SetSortOnClick(TRUE);

	// create image list for tree
	m_cImageList.Create(IDB_TREENODES, 16, 10, RGB(255, 0, 255));
	m_tree.SetImageList(&m_cImageList, TVSIL_NORMAL);
	m_tree.InsertColumn(0, "", LVCFMT_LEFT, 250);
	m_tree.InsertColumn(1, "ֵ", LVCFMT_RIGHT, 60);
	m_tree.InsertColumn(2, "", LVCFMT_LEFT, 150);
	m_tree.InsertColumn(3, "ַ", LVCFMT_RIGHT, 60);
	m_tree.InsertColumn(4, "С", LVCFMT_RIGHT, 60);
	m_tree.InsertColumn(5, "ע", LVCFMT_LEFT, 400);
	m_tree.SetGridLines(TRUE);

	//HTREEITEM hTmp = m_tree.InsertItem("parent1",0,0,0,0);
	//hTmp = m_tree.InsertItem("parent1",0,0,0,hTmp);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBmpFileViewDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBmpFileViewDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		//TreeListı߿
		RECT rcTree;
		this->GetItemRect(IDC_TREELIST1, &rcTree);
		//Ϊ˻Ʊ߿Ҫѿͻ
		::InflateRect(&rcTree, 2, 2);		

		CClientDC dc(this);
		dc.DrawEdge(&rcTree, EDGE_SUNKEN, BF_RECT);
		
		//ͼ
		/*
		if(m_CxImage.IsValid())
		{
			RECT rcdest;
			RECT _rcbanner;
			int destcx, destcy;
			int _width = m_CxImage.GetWidth();
			int _height = m_CxImage.GetHeight();

			this->GetItemRect(IDC_STATIC_BANNER, &_rcbanner);
			::InflateRect(&_rcbanner, 4, 4);
			
			double f1 = (_rcbanner.right - _rcbanner.left)*1.0 / _width;
			double f2 = (_rcbanner.bottom - _rcbanner.top)*1.0 / _height;
			double f = min(f1, f2);
			destcx = (int)(_width * f);
			destcy = (int)(_height * f);
			rcdest.left = _rcbanner.left + (_rcbanner.right - _rcbanner.left - destcx)/2;
			rcdest.top = _rcbanner.top + (_rcbanner.bottom - _rcbanner.top - destcy)/2;
			rcdest.right = rcdest.left + destcx;
			rcdest.bottom = rcdest.top + destcy;
			dc.SetStretchBltMode(HALFTONE);
			
			m_CxImage.Stretch(dc.GetSafeHdc(), rcdest);

			//Ʊ߿
			HGDIOBJ hOldBrush = ::SelectObject(dc.GetSafeHdc(), ::GetStockObject(NULL_BRUSH));
			::Rectangle(dc.GetSafeHdc(), rcdest.left - 2, rcdest.top - 2, rcdest.right + 2, rcdest.bottom + 2);
			::SelectObject(dc.GetSafeHdc(), hOldBrush);
		}
		*/
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBmpFileViewDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//ȡͻ
void CBmpFileViewDlg::GetItemRect(int ctlId, LPRECT lpRect)
{
	POINT pt = { 0, 0 };
	//õͻʼĻ
	::ClientToScreen(this->GetSafeHwnd(), &pt);
	//õؼĻ
	this->GetDlgItem(ctlId)->GetWindowRect(lpRect);
	lpRect->left -= pt.x;
	lpRect->top -= pt.y;
	lpRect->right -= pt.x;
	lpRect->bottom -= pt.y;
}

//һͼļ
void CBmpFileViewDlg::OnOpenimage() 
{
	// TODO: Add your command handler code here
	CFileDialog dlg(TRUE, 
		NULL,		//Ĭϵչ, ļʱҪԶ׷ӣ
		NULL,	//Ĭϵļ
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Image Files (*.bmp; *.cur; *.ico)|*.bmp;*.cur;*.ico|"
			"PE Files (*.exe; *.dll; *.ocx)|*.exe;*.dll;*.ocx|"
			"Photoshop Files (*.psd)|*.psd|"
			"All Supported Files (*.bmp; *.cur; *.ico; *.exe; *.dll; *.ocx; *.psd)|*.bmp;*.cur;*.ico;*.exe;*.dll;*.ocx;*.psd||",
		this);

	dlg.m_ofn.nFilterIndex = 4; //1-based;

	if(dlg.DoModal() == IDOK)
	{
		//ɳ©꣺CCmdTarget::BeginWaitCursor();
		this->BeginWaitCursor(); //::SetCursor(::LoadCursor(NULL, IDC_WAIT));
		//ѵǰڵɢ
		this->m_wndMyTreeList.m_tree.DeleteAllItems();
		
		CString ext = dlg.GetFileExt();
		if(ext.CompareNoCase("bmp") == 0)
		{
			if(this->m_pBmp == NULL)
				this->m_pBmp = new CBmpFile();
			if(this->m_pBmp->LoadFile(dlg.GetPathName()))
			{
				//ؽڵ
				this->FillTreeList(this->m_pBmp);
				//ͼƬ
				//m_CxImage.Destroy();//ԭͼƬ
				//m_CxImage.Load(dlg.GetPathName(), CXIMAGE_FORMAT_BMP);
			}
		}
		else if(ext.CompareNoCase("ico") == 0 
			|| ext.CompareNoCase("cur") == 0)
		{
			if(this->m_pIco == NULL)
				this->m_pIco = new CIcoFile();
			if(this->m_pIco->LoadFile(dlg.GetPathName()))
			{
				//ؽڵ
				this->FillTreeList(this->m_pIco);
			}
		}
		else if(ext.CompareNoCase("exe") == 0
			|| ext.CompareNoCase("dll") == 0
			|| ext.CompareNoCase("ocx") == 0
			//|| ext.CompareNoCase("obj") == 0
			)
		{
			if(this->m_pPe == NULL)
				this->m_pPe = new CPeFile();
			if(this->m_pPe->LoadFile(dlg.GetPathName()))
			{
				this->FillTreeList(this->m_pPe);
			}
		}
		else if(ext.CompareNoCase("psd") == 0)
		{
			if(this->m_pPsd == NULL)
				this->m_pPsd = new CPsdFile();

			if(this->m_pPsd->LoadFile(dlg.GetPathName()))
			{
				this->FillTreeList(this->m_pPsd);
			}
		}
		//this->SetDlgItemText(IDC_TB_MSG, dlg.GetFileName());
		this->m_Edit.SetWindowText(dlg.GetPathName());
		this->EndWaitCursor(); //::SetCursor(::LoadCursor(NULL, IDC_ARROW));
	}	
}

void CBmpFileViewDlg::OnAbout()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CBmpFileViewDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	POINT pt;
	RECT rc;

	if(this->m_Edit.GetSafeHwnd() != NULL)
	{
		this->m_Edit.GetWindowRect(&rc);
		pt.x = rc.left;
		pt.y = rc.top;

		::ScreenToClient(this->GetSafeHwnd(), &pt);
		this->m_Edit.SetWindowPos(NULL, 0, 0, cx - 8 - pt.x, (rc.bottom - rc.top), 
			SWP_NOSENDCHANGING | SWP_NOOWNERZORDER | SWP_NOMOVE);
	}

	if(this->m_wndMyTreeList.GetSafeHwnd() != NULL)
	{	
		this->m_wndMyTreeList.GetWindowRect(&rc);
		pt.x = rc.left;
		pt.y = rc.top;

		::ScreenToClient(this->GetSafeHwnd(), &pt);
		this->m_wndMyTreeList.SetWindowPos(NULL, 0, 0, cx - 10 - pt.x, cy - 10 - pt.y, 
			SWP_NOSENDCHANGING | SWP_NOOWNERZORDER | SWP_NOMOVE);
	}
}

void CBmpFileViewDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	if(this->m_pBmp != NULL)
	{
		delete this->m_pBmp;
		this->m_pBmp = NULL;
	}

	if(this->m_pIco != NULL)
	{
		delete this->m_pIco;
		this->m_pIco = NULL;
	}

	if(this->m_pPe != NULL)
	{
		delete this->m_pPe;
		this->m_pPe = NULL;
	}

	if(this->m_pPsd != NULL)
	{
		delete this->m_pPsd;
		this->m_pPsd = NULL;
	}
	//m_CxImage.Destroy();//ԭͼƬ
}

//һbyteڵ
HTREEITEM CBmpFileViewDlg::Append_BYTE(LPCTSTR name, BYTE val, size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
	LPCTSTR memo)
{
	HTREEITEM hNode;
	char szSize_BYTE[] = "1";
	char szData[16], szAddr[16];

	hNode = _tree.InsertItem(name, IMAGEINDEX_BYTE, IMAGEINDEX_BYTE, hParent, hInsertAfter);
	sprintf(szData, "%02X", val);
	sprintf(szAddr, "%08X", *pAddress);
	//0  1 ֵ 2  3 ַ 4 С 5 ע
	_tree.SetItemText(hNode, 1, szData);
	_tree.SetItemText(hNode, 2, "BYTE", RGB(0, 0, 0xFF));
	_tree.SetItemText(hNode, 3, szAddr);
	_tree.SetItemText(hNode, 4, szSize_BYTE); //sizeof(BYTE)
	if(memo != NULL)
		_tree.SetItemText(hNode, 5, memo, RGB(0, 0x80, 0));
	*pAddress += sizeof(BYTE);
	return hNode;
}

//һwordڵ
HTREEITEM CBmpFileViewDlg::Append_WORD(LPCTSTR name, WORD val, size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
	LPCTSTR memo)
{
	HTREEITEM hNode;
	char szSize_WORD[] = "2";
	char szData[16], szAddr[16];

	hNode = _tree.InsertItem(name, IMAGEINDEX_WORD, IMAGEINDEX_WORD, hParent, hInsertAfter);
	sprintf(szData, "%04X", val);
	sprintf(szAddr, "%08X", *pAddress);
	//0  1 ֵ 2  3 ַ 4 С 5 ע
	_tree.SetItemText(hNode, 1, szData);
	_tree.SetItemText(hNode, 2, "WORD", RGB(0, 0, 0xFF));
	_tree.SetItemText(hNode, 3, szAddr);
	_tree.SetItemText(hNode, 4, szSize_WORD); //sizeof(BYTE)
	if(memo != NULL)
		_tree.SetItemText(hNode, 5, memo, RGB(0, 0x80, 0));
	*pAddress += sizeof(WORD);
	return hNode;
}

//һwordڵ
HTREEITEM CBmpFileViewDlg::Append_DWORD(LPCTSTR name, DWORD val, size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
	LPCTSTR memo)
{
	HTREEITEM hNode;
	char szSize_DWORD[] = "4";
	char szData[16], szAddr[16];

	hNode = _tree.InsertItem(name, IMAGEINDEX_DWORD, IMAGEINDEX_DWORD,  hParent, hInsertAfter);
	sprintf(szData, "%08X", val);
	sprintf(szAddr, "%08X", *pAddress);
	//0  1 ֵ 2  3 ַ 4 С 5 ע
	_tree.SetItemText(hNode, 1, szData);
	_tree.SetItemText(hNode, 2, "DWORD", RGB(0, 0, 0xFF));
	_tree.SetItemText(hNode, 3, szAddr);
	_tree.SetItemText(hNode, 4, szSize_DWORD); //sizeof(BYTE)
	if(memo != NULL)
		_tree.SetItemText(hNode, 5, memo, RGB(0, 0x80, 0));
	*pAddress += sizeof(DWORD);
	return hNode;
}

//һLongڵ
HTREEITEM CBmpFileViewDlg::Append_LONG(LPCTSTR name, LONG val, size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
	LPCTSTR memo)
{
	HTREEITEM hNode;
	char szSize_Long[] = "4";
	char szData[16], szAddr[16];

	hNode = _tree.InsertItem(name, IMAGEINDEX_DWORD, IMAGEINDEX_DWORD,  hParent, hInsertAfter);
	sprintf(szData, "%08X", val);
	sprintf(szAddr, "%08X", *pAddress);
	//0  1 ֵ 2  3 ַ 4 С 5 ע
	_tree.SetItemText(hNode, 1, szData);
	_tree.SetItemText(hNode, 2, "LONG", RGB(0, 0, 0xFF));
	_tree.SetItemText(hNode, 3, szAddr);
	_tree.SetItemText(hNode, 4, szSize_Long); //sizeof(BYTE)
	if(memo != NULL)
		_tree.SetItemText(hNode, 5, memo, RGB(0, 0x80, 0));
	*pAddress += sizeof(DWORD);
	return hNode;
}

//һchar[8] (PEʽеĽ)
HTREEITEM CBmpFileViewDlg::Append_CHAR8(LPCTSTR name, BYTE szVal[], size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
	LPCTSTR memo)
{
	HTREEITEM hNode;
	char szAddr[16], defmemo[32];

	hNode = _tree.InsertItem(name, IMAGEINDEX_LONGLONG, IMAGEINDEX_LONGLONG,  hParent, hInsertAfter);

	sprintf(szAddr, "%08X", *pAddress);

	//0  1 ֵ 2  3 ַ 4 С 5 ע
	//ﲻֵˣΪҪӡ8ֽڣ̫
	//_tree.SetItemText(hNode, 1, szData);
	_tree.SetItemText(hNode, 2, "BYTE[8]");
	_tree.SetItemText(hNode, 3, szAddr);
	_tree.SetItemText(hNode, 4, "8"); //sizeof(BYTE)
	
	//ĬϵıעǸchar[8]ַʽעַ 0 Ϊ\0
	if(memo == NULL)
	{
		int i;
		char *p = defmemo;
		for(i=0; i<8; i++)
		{
			if(szVal[i])
			{
				*p = szVal[i], p++;
			}
			else
			{
				*p = '\\', p++;
				*p = '0',  p++;
			}
		}
		*p = 0; //ַβ
		_tree.SetItemText(hNode, 5, defmemo, RGB(0, 0x80, 0));
	}
	else
		_tree.SetItemText(hNode, 5, memo, RGB(0, 0x80, 0));

	*pAddress += 8;	//sizeof char[8]
	return hNode;
}

//һRGBQUADڵ
HTREEITEM CBmpFileViewDlg::Append_RGBQUAD(LPCTSTR name, RGBQUAD* pQuad, size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree)
{
	HTREEITEM hNode;
	char szSize_Quad[] = "4";
	char szData[16], szAddr[16], szMemo[24];

	hNode = _tree.InsertItem(name, IMAGEINDEX_RGBQUAD, IMAGEINDEX_RGBQUAD,  hParent, hInsertAfter);
	sprintf(szData, "%08X", *(LPDWORD)pQuad);
	sprintf(szAddr, "%08X", *pAddress);
	sprintf(szMemo, "RGB(%3d,%3d,%3d)", pQuad->rgbRed, pQuad->rgbGreen, pQuad->rgbBlue);
	//0  1 ֵ 2  3 ַ 4 С 5 ע
	_tree.SetItemText(hNode, 1, szData);
	_tree.SetItemText(hNode, 2, "RGBQUAD");
	_tree.SetItemText(hNode, 3, szAddr);
	_tree.SetItemText(hNode, 4, szSize_Quad); //sizeof(BYTE)
	_tree.SetItemText(hNode, 5, szMemo, RGB(0, 0x80, 0));
	*pAddress += sizeof(RGBQUAD);
	return hNode;
}

//һlpVoidڵ㣨ͨݽڵ㣬ע⣬ַԾ
HTREEITEM CBmpFileViewDlg::Append_LPVOID(LPCTSTR name, size_t nSize, LPCTSTR type, size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
	LPCTSTR memo, int nImage)
{
	HTREEITEM hNode;
	char szSize[16], szAddr[16];

	hNode = _tree.InsertItem(name, nImage, nImage, hParent, hInsertAfter);
	sprintf(szSize, "%X", nSize);
	sprintf(szAddr, "%08X", *pAddress);
	//0  1 ֵ 2  3 ַ 4 С 5 ע
	_tree.SetItemText(hNode, 2, type);
	_tree.SetItemText(hNode, 3, szAddr);
	_tree.SetItemText(hNode, 4, szSize); //sizeof(BYTE)
	if(memo != NULL)
		_tree.SetItemText(hNode, 5, memo, RGB(0, 0x80, 0));

	*pAddress += nSize;
	return hNode;
}

//һstructڵ㣨ڵ㣬ע⣬ַԾ
HTREEITEM CBmpFileViewDlg::Append_STRUCT(LPCTSTR name, size_t nSize, LPCTSTR type, size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
	LPCTSTR memo, int nImage)
{
	HTREEITEM hNode;
	char szSize[16], szAddr[16];

	hNode = _tree.InsertItem(name, nImage, nImage, hParent, hInsertAfter);
	sprintf(szSize, "%X", nSize);
	sprintf(szAddr, "%08X", *pAddress);
	//0  1 ֵ 2  3 ַ 4 С 5 ע
	_tree.SetItemText(hNode, 2, type);
	_tree.SetItemText(hNode, 3, szAddr);
	_tree.SetItemText(hNode, 4, szSize); //sizeof(BYTE)
	if(memo != NULL)
		_tree.SetItemText(hNode, 5, memo, RGB(0, 0x80, 0));
	return hNode;
}

// BITMAPINFO һڵ, BitmapInfoڵ
HTREEITEM CBmpFileViewDlg::Append_BITMAPINFO(LPCTSTR name, 
	LPBITMAPINFO lpInfo, int paletteSize, size_t* pAddress,
	HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree)
{
	HTREEITEM hInfo, hInfoHeader, hChild, hColors;
	char memo[128];
	//===================================================
	// BITMAPINFO
	//   |_BITMAPINFOHEADER 
	//   |_bmiColos
	//===================================================
	size_t nSize_Info = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * paletteSize;
	hInfo = Append_STRUCT(name, nSize_Info, "BITMAPINFO", pAddress, hParent, hInsertAfter, _tree);
	_tree.SetItemColor(hInfo, RGB(0, 0, 255), FALSE);
	_tree.SetItemBkColor(hInfo, TRUE, RGB(255, 255, 200), FALSE);
	hInfoHeader = Append_STRUCT("bmiHeader", sizeof(BITMAPINFOHEADER), "BITMAPINFOHEADER", pAddress, hInfo, NULL, _tree);
	//_tree.SetItemColor(hInfoHeader, color_gray, FALSE);
	_tree.SetItemBkColor(hInfoHeader, TRUE, RGB(200, 255, 255), FALSE);


	//BITMAPINFOHEADERӽڵ
	BITMAPINFOHEADER& header = lpInfo->bmiHeader;
	hChild = Append_DWORD("biSize", header.biSize, pAddress, hInfoHeader, NULL, _tree, "sizeof(bmiHeader) = 40 bytes");
	sprintf(memo, " = %ld pixels", header.biWidth);
	hChild = Append_LONG("biWidth", header.biWidth, pAddress, hInfoHeader, hChild, _tree, memo);
	sprintf(memo, "߶ = %ld pixels", header.biHeight);
	hChild = Append_LONG("biHeight", header.biHeight, pAddress, hInfoHeader, hChild, _tree, memo);
	hChild = Append_WORD("biPlanes", header.biPlanes, pAddress, hInfoHeader, hChild, _tree, "Ϊ1");
	sprintf(memo, "λ = %d bpp", header.biBitCount);
	hChild = Append_WORD("biBitCount", header.biBitCount, pAddress, hInfoHeader, hChild, _tree, memo);
	switch(header.biCompression)
	{
	case BI_RGB:  strcpy(memo, "BI_RGB");  break;
	case BI_RLE8: strcpy(memo, "BI_RLE8"); break;
	case BI_RLE4: strcpy(memo, "BI_RLE4"); break;
	case BI_BITFIELDS: strcpy(memo, "BI_BITFIELDS"); break;

#ifndef BI_JPEG
#define BI_JPEG       4L
#endif

	case BI_JPEG: strcpy(memo, "BI_JPEG"); break;

#ifndef BI_PNG
#define BI_PNG        5L
#endif

	case BI_PNG:  strcpy(memo, "BI_PNG");  break;
	default: strcpy(memo, "δ֪"); break;
	}
	hChild = Append_DWORD("biCompression", header.biCompression, pAddress, hInfoHeader, hChild, _tree, memo);
	hChild = Append_DWORD("biSizeImage", header.biSizeImage, pAddress, hInfoHeader, hChild, _tree, "ͼСΪ0");
	sprintf(memo, "ˮƽֱ: %ld /; %ld /Ӣ", header.biXPelsPerMeter, (int)(header.biXPelsPerMeter*0.0254+0.5));
	hChild = Append_LONG("biXPelsPerMeter", header.biXPelsPerMeter, pAddress, hInfoHeader, hChild, _tree, memo);
	sprintf(memo, "ֱֱ: %ld /; %ld /Ӣ", header.biYPelsPerMeter, (int)(header.biYPelsPerMeter*0.0254+0.5));
	hChild = Append_LONG("biYPelsPerMeter", header.biYPelsPerMeter, pAddress, hInfoHeader, hChild, _tree, memo);
	hChild = Append_DWORD("biClrUsed", header.biClrUsed, pAddress, hInfoHeader, hChild, _tree, "ʹõɫ");
	hChild = Append_DWORD("biClrImportant", header.biClrImportant, pAddress, hInfoHeader, hChild, _tree, "ͼɫ, 0ʾȫҪ");

	//
	// bmiColors : ڼصɫڵ
	//
	int i;
	if(paletteSize > 0)
	{
		RGBQUAD* pQuad = lpInfo->bmiColors;
		char nodename[48];
		size_t nSize_Palette = sizeof(RGBQUAD) * paletteSize;
		sprintf(memo, "ɫ,  = %ld", paletteSize);
		hColors = Append_STRUCT("bmiColors", nSize_Palette, "RGBQUAD[]", pAddress, hInfo, hInfoHeader, _tree, memo);
		//_tree.SetItemColor(hColors, color_gray, FALSE);
		_tree.SetItemBkColor(hColors, TRUE, RGB(200, 255, 255), FALSE);

		hChild = NULL;
		for(i = 0; i < paletteSize; i++)
		{
			//%3d:  __a
			//%-3d: a__
			sprintf(nodename, "[%3d]", i); 
			hChild = Append_RGBQUAD(nodename, pQuad, pAddress, hColors, hChild, _tree); 
			++pQuad; //ƶһɫ
		}
	}
	return hInfo;
}

//λͼϢصTreeList
void CBmpFileViewDlg::FillTreeList(CBmpFile* pBmp)
{
	size_t address = 0; //ļַ
	char memo[256];
	HTREEITEM hFileHeader, hInfo;
	HTREEITEM hChild = NULL;
	COLORREF color_gray = RGB(128, 128, 128); //::GetSysColor(COLOR_GRAYTEXT);

	//0  1 ֵ 2  3 ַ 4 С 5 ע
	CTreeListCtrl& _tree = this->m_wndMyTreeList.m_tree;

	//===========================================
	// BITMAPFILEHEADER
	//===========================================
	hFileHeader = Append_STRUCT("fileHeader", sizeof(BITMAPFILEHEADER), "BITMAPFILEHEADER", &address, TVI_ROOT, NULL, _tree, "ļͷ");
	_tree.SetItemColor(hFileHeader, RGB(0, 0, 255), FALSE);
	_tree.SetItemBkColor(hFileHeader, TRUE, RGB(255, 255, 200), FALSE);


	hChild = Append_WORD("bfType", pBmp->m_fileHeader.bfType, &address, hFileHeader, hChild, _tree, "ͱ־ = BM");
	sprintf(memo, "ļС = %lu bytes", pBmp->m_fileHeader.bfSize);
	hChild = Append_DWORD("bfSize", pBmp->m_fileHeader.bfSize, &address, hFileHeader, hChild, _tree, memo);
	hChild = Append_WORD("bfReserved1", pBmp->m_fileHeader.bfReserved1, &address, hFileHeader, hChild, _tree);
	hChild = Append_WORD("bfReserved2", pBmp->m_fileHeader.bfReserved2, &address, hFileHeader, hChild, _tree);
	hChild = Append_DWORD("bfOffBits", pBmp->m_fileHeader.bfOffBits, &address, hFileHeader, hChild, _tree, " (lpBits) ַ");

	//===========================================
	// BITMAPINFO
	//   |_BITMAPINFOHEADER 
	//   |_bmiColos
	//===========================================
	hInfo = this->Append_BITMAPINFO("bitmapInfo", pBmp->m_pInfo, pBmp->GetPaletteSize(), &address, 
		TVI_ROOT, hFileHeader, _tree);

	//============================================
	// һڵ㣺ݿ
	//============================================
	sprintf(memo, ", ɨп = %ld bytes", pBmp->GetLineSize());
	HTREEITEM hBits = Append_LPVOID("lpBits", pBmp->GetBitsSize(), "LPVOID", &address, TVI_ROOT, hInfo, _tree, memo);
}

//λͼϢصTreeList
void CBmpFileViewDlg::FillTreeList(CIcoFile* pIco)
{
	char memo[128], name[48];
	HTREEITEM hFileHeader, hChild = NULL;
	HTREEITEM hEntries, hEntry = NULL;
	HTREEITEM hImages, hImage = NULL;
	size_t address = 0;
	size_t nSize, i;
	//0  1 ֵ 2  3 ַ 4 С 5 ע
	CTreeListCtrl& _tree = this->m_wndMyTreeList.m_tree;

	//===========================================
	// ICONDIR
	//===========================================
	hFileHeader = Append_STRUCT("iconDir", sizeof(ICONFILEHEADER), "ICONDIR", &address, TVI_ROOT, NULL, _tree);
	hChild = Append_WORD("idReserved", pIco->m_fileHeader.idReserved, &address, hFileHeader, hChild, _tree);
	hChild = Append_WORD("idType", pIco->m_fileHeader.idType, &address, hFileHeader, hChild, _tree, "1-icons; 2-cursors");
	sprintf(memo, "ͼ = %d", pIco->m_fileHeader.idCount); 
	hChild = Append_WORD("idCount", pIco->m_fileHeader.idCount, &address, hFileHeader, hChild, _tree, memo);

	//===========================================
	// ICON Entries
	//===========================================
	nSize = sizeof(ICONDIRENTRY) * pIco->GetImgCount();
	hEntries = Append_STRUCT("idEntries", nSize, "ICONDIRENTRY[]", &address, TVI_ROOT, hFileHeader, _tree);
	for(i = 0; i < pIco->GetImgCount(); i++)
	{
		//icon dir entry:
		sprintf(name, "idEntries[%d]", i);
		hEntry = Append_STRUCT(name, sizeof(ICONDIRENTRY), "ICONDIRENTRY", &address, hEntries, hEntry, _tree);
		sprintf(memo, " = %d pixels, 255ʱbitmapInfoHeaderΪ׼", pIco->m_pEntries[i].bWidth);
		hChild = Append_BYTE("bWidth", pIco->m_pEntries[i].bWidth, &address, hEntry, NULL, _tree, memo);
		sprintf(memo, "߶ = %d pixels, 255ʱbitmapInfoHeaderΪ׼", pIco->m_pEntries[i].bHeight);
		hChild = Append_BYTE("bHeight", pIco->m_pEntries[i].bHeight, &address, hEntry, hChild, _tree, memo);
		sprintf(memo, "ɫ = %d, bpp>=8ʱΪ0", pIco->m_pEntries[i].bColorCount);
		hChild = Append_BYTE("bColorCount", pIco->m_pEntries[i].bColorCount, &address, hEntry, hChild, _tree, memo);
		hChild = Append_BYTE("bReserved", pIco->m_pEntries[i].bReserved, &address, hEntry, hChild, _tree);
		hChild = Append_WORD("wPlanes", pIco->m_pEntries[i].wPlanes, &address, hEntry, hChild, _tree);
		sprintf(memo, "λ = %d bpp", pIco->m_pEntries[i].wBitCount);
		hChild = Append_WORD("wBitCount", pIco->m_pEntries[i].wBitCount, &address, hEntry, hChild, _tree, memo);
		sprintf(memo, "ԴС = %ld bytes", pIco->m_pEntries[i].dwBytesInRes);
		hChild = Append_DWORD("dwBytesInRes", pIco->m_pEntries[i].dwBytesInRes, &address, hEntry, hChild, _tree, memo);
		hChild = Append_DWORD("dwImageOffset", pIco->m_pEntries[i].dwImageOffset, &address, hEntry, hChild, _tree, "Դַ");
	}

	//===========================================
	// ICON Images
	//===========================================
	nSize = pIco->GetSizeOfAllImages();
	hImages = Append_STRUCT("images", nSize, "ICONIMAGE[]", &address, TVI_ROOT, hEntries, _tree, "headerеĸ߶ʵʵĶ");
	for(i = 0; i < pIco->GetImgCount(); i++)
	{
		sprintf(name, "images[%d]", i);
		nSize = pIco->GetSizeOfImage(i);
		hImage = Append_STRUCT(name, nSize, "ICONIMAGE", &address, hImages, hImage, _tree);
		hChild = Append_BITMAPINFO("bitmapInfo", 
			pIco->m_pImages[i].lpInfo,
			pIco->m_pImages[i].nPaletteSize,
			&address,
			hImage, NULL, _tree);

		sprintf(memo, "XOR mask, ɨп = %ld bytes", pIco->m_pImages[i].nLineSize_XOR);
		hChild = Append_LPVOID("lpBits_XOR", 
			pIco->m_pImages[i].nSize_XOR, "LPVOID", &address,
			hImage, hChild, _tree, memo);

		sprintf(memo, "AND mask, ɨп = %ld bytes", pIco->m_pImages[i].nLineSize_AND);
		hChild = Append_LPVOID("lpBits_AND", 
			pIco->m_pImages[i].nSize_AND, "LPVOID", &address,
			hImage, hChild, _tree, memo);
	}
}

//PEļĽڵ
void CBmpFileViewDlg::FillTreeList(CPeFile *pPe)
{
	char memo[128], name[48];
	size_t address = 0;
	int i;

	HTREEITEM hDosHeader;
	HTREEITEM hDosStub;
	
	HTREEITEM hNtHeaders;
	HTREEITEM hFileHeader;
	HTREEITEM hOptionalHeader;
	HTREEITEM hDataDirs;
	HTREEITEM hDataDir = NULL;

	//IMAGE_SECTION_HEADER[]
	HTREEITEM hSectionHeaders;
	HTREEITEM hSectionHeader = NULL;
	
	//Dummy Bytes
	HTREEITEM hDummy;

	//Section Bodys
	HTREEITEM hSections;
	
	//ӽĸ
	HTREEITEM hChild = NULL;

	//0  1 ֵ 2  3 ַ 4 С 5 ע
	CTreeListCtrl& _tree = this->m_wndMyTreeList.m_tree;

	//
	// [1] IMAGE_DOS HEADER
	//
	hDosHeader = Append_STRUCT("dosHeader", sizeof(IMAGE_DOS_HEADER), "IMAGE_DOS_HEADER", &address,
		TVI_ROOT, NULL, _tree, "DOS Header");

	hChild = Append_WORD("e_magic",	pPe->m_dosHeader.e_magic, &address, 
		hDosHeader, hChild, _tree, "Magic number: MZ");
	hChild = Append_WORD("e_cblp",	pPe->m_dosHeader.e_cblp, &address, 
		hDosHeader, hChild, _tree, "Bytes on last page of file");
	hChild = Append_WORD("e_cp",	pPe->m_dosHeader.e_cp, &address, 
		hDosHeader, hChild, _tree, "Pages in file");
	hChild = Append_WORD("e_crlc",	pPe->m_dosHeader.e_crlc, &address, 
		hDosHeader, hChild, _tree, "Relocations");
	hChild = Append_WORD("e_cparhdr", pPe->m_dosHeader.e_cparhdr, &address, 
		hDosHeader, hChild, _tree, "Size of header in paragraphs");
	hChild = Append_WORD("e_minalloc", pPe->m_dosHeader.e_minalloc, &address, 
		hDosHeader, hChild, _tree, "Minimum extra paragraphs needed");
	hChild = Append_WORD("e_maxalloc", pPe->m_dosHeader.e_maxalloc, &address, 
		hDosHeader, hChild, _tree, "Maximum extra paragraphs needed");
	hChild = Append_WORD("e_ss", pPe->m_dosHeader.e_ss, &address, 
		hDosHeader, hChild, _tree, "Initial (relative) SS value");
	hChild = Append_WORD("e_sp", pPe->m_dosHeader.e_sp, &address, 
		hDosHeader, hChild, _tree, "Initial SP value");
	hChild = Append_WORD("e_csum", pPe->m_dosHeader.e_csum, &address, 
		hDosHeader, hChild, _tree, "Checksum");
	hChild = Append_WORD("e_ip", pPe->m_dosHeader.e_ip, &address, 
		hDosHeader, hChild, _tree, "Initial IP value");
	hChild = Append_WORD("e_cs", pPe->m_dosHeader.e_cs, &address, 
		hDosHeader, hChild, _tree, "Initial (relative) CS value");
	hChild = Append_WORD("e_lfarlc", pPe->m_dosHeader.e_lfarlc, &address, 
		hDosHeader, hChild, _tree, "File address of relocation table");
	hChild = Append_WORD("e_ovno", pPe->m_dosHeader.e_ovno, &address, 
		hDosHeader, hChild, _tree, "Overlay number");
	hChild = Append_LPVOID("e_res[4]", sizeof(WORD)*4, "WORD[4]", &address, 
		hDosHeader, hChild, _tree, "Reserved words", IMAGEINDEX_LONGLONG);
	hChild = Append_WORD("e_oemid", pPe->m_dosHeader.e_oemid, &address, 
		hDosHeader, hChild, _tree, "OEM identifier (for e_oeminfo)");
	hChild = Append_WORD("e_oeminfo", pPe->m_dosHeader.e_oeminfo, &address, 
		hDosHeader, hChild, _tree, "OEM information; e_oemid specific");
	hChild = Append_LPVOID("e_res2[10]", sizeof(WORD)*10, "WORD[10]", &address, 
		hDosHeader, hChild, _tree, "Reserved words");
	hChild = Append_LONG("e_lfanew", pPe->m_dosHeader.e_lfanew, &address, 
		hDosHeader, hChild, _tree, "File address of new exe header");

	//
	// [2] DOS STUB
	//
	hDosStub = Append_LPVOID("dosStub", pPe->GetDosStubSize(), "LPVOID", &address,
		TVI_ROOT, hDosHeader, _tree, "DOS Stub");

	//
	// [3] IMAGE_NT_HEADERS
	//
	hNtHeaders = Append_STRUCT("ntHeaders", sizeof(IMAGE_NT_HEADERS), "IMAGE_NT_HEADERS", &address,
		TVI_ROOT, hDosStub, _tree, "PE Header");

	hChild = Append_DWORD("Signature", pPe->m_ntHeaders.Signature, &address,
		hNtHeaders, NULL, _tree, "PEǩ: PE\\0\\0");

	//
	//		|_IMAGE_FILE_HEADER
	//
	hFileHeader = Append_STRUCT("fileHeader", sizeof(IMAGE_FILE_HEADER), "IMAGE_FILE_HEADER", &address,
		hNtHeaders, hChild, _tree, "file header");

	switch(pPe->m_ntHeaders.FileHeader.Machine)
	{
	case IMAGE_FILE_MACHINE_I386:  strcpy(memo, "Architecture: x86"); break;
	case IMAGE_FILE_MACHINE_IA64:  strcpy(memo, "Architecture: Intel IPF"); break;

#ifndef IMAGE_FILE_MACHINE_AMD64
#define IMAGE_FILE_MACHINE_AMD64             0x8664  // AMD64 (K8)
#endif

	case IMAGE_FILE_MACHINE_AMD64: strcpy(memo, "Architecture: x64"); break;
	default: strcpy(memo, "Architecture: unknown"); break;
	}
	hChild = Append_WORD("Machine", pPe->m_ntHeaders.FileHeader.Machine, &address,
		hFileHeader, NULL, _tree, memo);

	sprintf(memo, "() = %ld", pPe->m_ntHeaders.FileHeader.NumberOfSections);
	hChild = Append_WORD("NumberOfSections", pPe->m_ntHeaders.FileHeader.NumberOfSections, &address,
		hFileHeader, hChild, _tree, memo);

	//=================
	//	TimeDataStamp
	//=================
	
	//CTime time_Base(1970, 1, 1, 0, 0, 0); //1970-1-1 00:00:00
	//time_t _secs = pPe->m_ntHeaders.FileHeader.TimeDateStamp;
	//CTimeSpan ts_seconds(_secs);
	//time_Base += ts_seconds;
	//sprintf(memo, "ʱ: %s. (%lu secs from 1970-1-1)",
	//	time_Base.Format("%Y-%m-%d %H:%M:%S"));

	SYSTEMTIME st_Base, st_Build;
	::memset(&st_Base, 0, sizeof(st_Base));
	st_Base.wYear = 1970;
	st_Base.wMonth = 1;
	st_Base.wDay = 1;
	this->MyAddSeconds(&st_Base, &st_Build, pPe->m_ntHeaders.FileHeader.TimeDateStamp);
	sprintf(memo, " %04d-%d-%d %02d:%02d:%02d (secs from 1970-1-1)",
		st_Build.wYear, st_Build.wMonth, st_Build.wDay,
		st_Build.wHour, st_Build.wMinute, st_Build.wSecond,
		pPe->m_ntHeaders.FileHeader.TimeDateStamp
		);	
	
	hChild = Append_DWORD("TimeDataStamp", pPe->m_ntHeaders.FileHeader.TimeDateStamp, &address,
		hFileHeader, hChild, _tree, memo);


	//PointerToSymbolTable
	hChild = Append_DWORD("PointerToSymbolTable", pPe->m_ntHeaders.FileHeader.PointerToSymbolTable, &address,
		hFileHeader, hChild, _tree, "ű");

	hChild = Append_DWORD("NumberOfSymbols", pPe->m_ntHeaders.FileHeader.NumberOfSymbols, &address,
		hFileHeader, hChild, _tree, "ű");

	//SizeOfOptionalHeader
	sprintf(memo, "sizeof(optionalHeader) = %d bytes", pPe->m_ntHeaders.FileHeader.SizeOfOptionalHeader);
	hChild = Append_WORD("SizeOfOptionalHeader", pPe->m_ntHeaders.FileHeader.SizeOfOptionalHeader, &address,
		hFileHeader, hChild, _tree, memo);

	if(pPe->m_ntHeaders.FileHeader.Characteristics & IMAGE_FILE_DLL)
		strcpy(memo, "ļ: DLL");
	else
		strcpy(memo, "ļ: "); 
	hChild = Append_WORD("Characteristics", pPe->m_ntHeaders.FileHeader.Characteristics, &address,
		hFileHeader, hChild, _tree, memo);

	//
	//		|_IMAGE_OPTIONAL_HEADER
	//
	hOptionalHeader = Append_STRUCT("optionalHeader", sizeof(IMAGE_OPTIONAL_HEADER), "IMAGE_OPTIONAL_HEADER", &address,
		hNtHeaders, hFileHeader, _tree, "optional file header");

	//Magic: state of the image file.
	switch(pPe->m_ntHeaders.OptionalHeader.Magic)
	{
	case IMAGE_NT_OPTIONAL_HDR32_MAGIC: strcpy(memo, "executable image (32-bit)"); break;
	case IMAGE_NT_OPTIONAL_HDR64_MAGIC: strcpy(memo, "executable image (64-bit)"); break;
	case IMAGE_ROM_OPTIONAL_HDR_MAGIC: strcpy(memo, "ROM image"); break;
	default: strcpy(memo, ""); break;
	}
	hChild = Append_WORD("Magic", pPe->m_ntHeaders.OptionalHeader.Magic, &address,
		hOptionalHeader, NULL, _tree, memo);

	//Linker Version
	sprintf(memo, "汾: %d.%d",
		pPe->m_ntHeaders.OptionalHeader.MajorLinkerVersion,
		pPe->m_ntHeaders.OptionalHeader.MinorLinkerVersion
		);
	hChild = Append_BYTE("MajorLinkerVersion", pPe->m_ntHeaders.OptionalHeader.MajorLinkerVersion, &address,
		hOptionalHeader, hChild, _tree, memo);

	hChild = Append_BYTE("MinorLinkerVersion", pPe->m_ntHeaders.OptionalHeader.MinorLinkerVersion, &address,
		hOptionalHeader, hChild, _tree);

	hChild = Append_DWORD("SizeOfCode", pPe->m_ntHeaders.OptionalHeader.SizeOfCode, &address,
		hOptionalHeader, hChild, _tree, "εĴС");

	hChild = Append_DWORD("SizeOfInitializedData", pPe->m_ntHeaders.OptionalHeader.SizeOfInitializedData, &address,
		hOptionalHeader, hChild, _tree, "ʼݶεܴС");

	hChild = Append_DWORD("SizeOfUninitializedData", pPe->m_ntHeaders.OptionalHeader.SizeOfUninitializedData, &address,
		hOptionalHeader, hChild, _tree, "δʼݶεܴС");

	hChild = Append_DWORD("AddressOfEntryPoint", pPe->m_ntHeaders.OptionalHeader.AddressOfEntryPoint, &address,
		hOptionalHeader, hChild, _tree, "image baseڵ, DLLѡ");

	hChild = Append_DWORD("BaseOfCode", pPe->m_ntHeaders.OptionalHeader.BaseOfCode, &address,
		hOptionalHeader, hChild, _tree, "image baseĴεַ");

	hChild = Append_DWORD("BaseOfData", pPe->m_ntHeaders.OptionalHeader.BaseOfData, &address,
		hOptionalHeader, hChild, _tree, "image baseݶεַ");

	//Image Base
	hChild = Append_DWORD("ImageBase", pPe->m_ntHeaders.OptionalHeader.ImageBase, &address,
		hOptionalHeader, hChild, _tree, "ڴַ, 64K, Ĭ: DLL-0x10000000, APP-0x00400000");

	//Section Alignment
	sprintf(memo, "ڴеĶ = %lu bytes, ĬΪϵͳҳС", pPe->m_ntHeaders.OptionalHeader.SectionAlignment);
	hChild = Append_DWORD("SectionAlignment", pPe->m_ntHeaders.OptionalHeader.SectionAlignment, &address,
		hOptionalHeader, hChild, _tree, memo);

	//File Alignment
	sprintf(memo, "ļеĶ = %lu bytes, [512B - 64KB]", pPe->m_ntHeaders.OptionalHeader.FileAlignment);
	hChild = Append_DWORD("FileAlignment", pPe->m_ntHeaders.OptionalHeader.FileAlignment, &address,
		hOptionalHeader, hChild, _tree, memo);

	//Operating System Version Required
	sprintf(memo, "ϵͳ汾: %ld.%ld",
		pPe->m_ntHeaders.OptionalHeader.MajorOperatingSystemVersion,
		pPe->m_ntHeaders.OptionalHeader.MinorOperatingSystemVersion
		);
	hChild = Append_WORD("MajorOperatingSystemVersion", pPe->m_ntHeaders.OptionalHeader.MajorOperatingSystemVersion, &address,
		hOptionalHeader, hChild, _tree, memo);

	hChild = Append_WORD("MinorOperatingSystemVersion", pPe->m_ntHeaders.OptionalHeader.MinorOperatingSystemVersion, &address,
		hOptionalHeader, hChild, _tree);

	//Image Version
	sprintf(memo, "ļ汾: %ld.%ld",
		pPe->m_ntHeaders.OptionalHeader.MajorImageVersion,
		pPe->m_ntHeaders.OptionalHeader.MinorImageVersion
		);
	hChild = Append_WORD("MajorImageVersion", pPe->m_ntHeaders.OptionalHeader.MajorImageVersion, &address,
		hOptionalHeader, hChild, _tree, memo);

	hChild = Append_WORD("MinorImageVersion", pPe->m_ntHeaders.OptionalHeader.MinorImageVersion, &address,
		hOptionalHeader, hChild, _tree);

	//Subsystem Version
	sprintf(memo, "ϵͳ汾: %ld.%ld",
		pPe->m_ntHeaders.OptionalHeader.MajorSubsystemVersion,
		pPe->m_ntHeaders.OptionalHeader.MinorSubsystemVersion
		);
	hChild = Append_WORD("MajorSubsystemVersion", pPe->m_ntHeaders.OptionalHeader.MajorSubsystemVersion, &address,
		hOptionalHeader, hChild, _tree, memo);

	hChild = Append_WORD("MinorSubsystemVersion", pPe->m_ntHeaders.OptionalHeader.MinorSubsystemVersion, &address,
		hOptionalHeader, hChild, _tree);

	hChild = Append_DWORD("Win32VersionValue", pPe->m_ntHeaders.OptionalHeader.Win32VersionValue, &address,
		hOptionalHeader, hChild, _tree, "reserved");

	//SizeOfImage
	sprintf(memo, "ӳӳС = %lu bytes ( SectionAlignment )",
		pPe->m_ntHeaders.OptionalHeader.SizeOfImage);
	hChild = Append_DWORD("SizeOfImage", pPe->m_ntHeaders.OptionalHeader.SizeOfImage, &address,
		hOptionalHeader, hChild, _tree, memo);

	//SizeOfHeaders
	sprintf(memo, "֮ǰݴС = %ld bytes ( FileAlignmeng )",
		pPe->m_ntHeaders.OptionalHeader.SizeOfHeaders);
	hChild = Append_DWORD("SizeOfHeaders", pPe->m_ntHeaders.OptionalHeader.SizeOfHeaders, &address,
		hOptionalHeader, hChild, _tree, memo);

	//CheckSum
	hChild = Append_DWORD("CheckSum", pPe->m_ntHeaders.OptionalHeader.CheckSum, &address,
		hOptionalHeader, hChild, _tree, "Image file checksum");

	//Subsystem:
	strcpy(memo, "ϵͳ: ");
	switch(pPe->m_ntHeaders.OptionalHeader.Subsystem)
	{
	case IMAGE_SUBSYSTEM_UNKNOWN: strcat(memo, "Unknown;"); break;
	case IMAGE_SUBSYSTEM_NATIVE:  strcat(memo, "ϵͳ"); break;
	case IMAGE_SUBSYSTEM_WINDOWS_CUI: strcat(memo, "Console"); break;
	case IMAGE_SUBSYSTEM_WINDOWS_GUI: strcat(memo, "GUI"); break;
	case IMAGE_SUBSYSTEM_OS2_CUI: strcat(memo, "OS/2 Console"); break;
	case IMAGE_SUBSYSTEM_POSIX_CUI: strcat(memo, "POSIX Console"); break;
	case IMAGE_SUBSYSTEM_WINDOWS_CE_GUI: strcat(memo, "WinCE GUI"); break;

#ifndef IMAGE_SUBSYSTEM_XBOX
#define IMAGE_SUBSYSTEM_XBOX  14
#endif

	case IMAGE_SUBSYSTEM_XBOX: strcat(memo, "XBox"); break;
	}
	hChild = Append_WORD("Subsystem", pPe->m_ntHeaders.OptionalHeader.Subsystem, &address,
		hOptionalHeader, hChild, _tree, memo);

	//Dll Characteristics
	if(pPe->m_ntHeaders.OptionalHeader.DllCharacteristics & 0x2000)
		strcpy(memo, "A WDM driver");
	else
		strcpy(memo, "");
	hChild = Append_WORD("DllCharacteristics", pPe->m_ntHeaders.OptionalHeader.DllCharacteristics, &address,
		hOptionalHeader, hChild, _tree, memo);

	//Size Of Stack
	hChild = Append_DWORD("SizeOfStackReserve", pPe->m_ntHeaders.OptionalHeader.SizeOfStackReserve, &address,
		hOptionalHeader, hChild, _tree, "ջС");

	hChild = Append_DWORD("SizeOfStackCommit", pPe->m_ntHeaders.OptionalHeader.SizeOfStackCommit, &address,
		hOptionalHeader, hChild, _tree, "ջύС");

	//Size Of Heap
	hChild = Append_DWORD("SizeOfHeapReserve", pPe->m_ntHeaders.OptionalHeader.SizeOfHeapReserve, &address,
		hOptionalHeader, hChild, _tree, "ѱС");

	hChild = Append_DWORD("SizeOfHeapCommit", pPe->m_ntHeaders.OptionalHeader.SizeOfHeapCommit, &address,
		hOptionalHeader, hChild, _tree, "ύС");

	hChild = Append_DWORD("LoaderFlags", pPe->m_ntHeaders.OptionalHeader.LoaderFlags, &address,
		hOptionalHeader, hChild, _tree, "ѷ");

	hChild = Append_DWORD("NumberOfRvaAndSizes", pPe->m_ntHeaders.OptionalHeader.NumberOfRvaAndSizes, &address,
		hOptionalHeader, hChild, _tree, "directory entries ");

	hDataDirs = Append_STRUCT("DataDirectory", sizeof(IMAGE_DATA_DIRECTORY)*16, "IMAGE_DATA_DIRECTORY[]", &address,
		hOptionalHeader, NULL, _tree);

	//DataDirectory˵(Ŀ¼˵, winnt.hеĶע)
	const char* dataDirComments[16] =
	{
		"export table",
		"import table",
		"resource table",
		"exception table",
		"certificate table",
		"base relocation table",
		"debugging information starting",
		"architecture-specific data",
		"RVA of global pointer",
		"thread local storage (TLS) table",
		"load configuration table",
		"bound import table",
		"import address table",
		"delay import descriptor",
		"COM runtime descriptor",
		"MSԴ޶˵"
	};

	for(i=0; i<16; i++)
	{
		sprintf(name, "DataDirectory[%02d]", i);
		hDataDir = Append_STRUCT(name, sizeof(IMAGE_DATA_DIRECTORY), "IMAGE_DATA_DIRECTORY", &address,
			hDataDirs, hDataDir, _tree, dataDirComments[i]);

		//ļַ
		if(pPe->m_ntHeaders.OptionalHeader.DataDirectory[i].VirtualAddress > 0)
		{
			DWORD fileAddr = pPe->RvaToFileAddress(pPe->m_ntHeaders.OptionalHeader.DataDirectory[i].VirtualAddress);
			sprintf(memo, "RVA (FileAddress: %08X)", fileAddr);
		}
		else
		{
			strcpy(memo, "NULL");
		}
		hChild = Append_DWORD("VirtualAddress", pPe->m_ntHeaders.OptionalHeader.DataDirectory[i].VirtualAddress, &address,
			hDataDir, NULL, _tree, memo);

		sprintf(memo, "size = %ld bytes", pPe->m_ntHeaders.OptionalHeader.DataDirectory[i].Size);
		hChild = Append_DWORD("Size", pPe->m_ntHeaders.OptionalHeader.DataDirectory[i].Size, &address,
			hDataDir, hChild, _tree, memo);
	}

	//
	// [4] IMAGE_SECTION_HEADER[]
	//
	hSectionHeaders = Append_STRUCT("sectionHeaders", sizeof(IMAGE_SECTION_HEADER)*pPe->GetSectionCount(), "IMAGE_SECTION_HEADER[]", &address,
		TVI_ROOT, hNtHeaders, _tree);

	for(i=0; i < pPe->GetSectionCount(); i++)
	{
		//
		//  |_ IMAGE_SECTION_HEADER[i]
		//
		sprintf(name, "sectionHeaders[%d]", i);

		strncpy(memo, (LPCTSTR)pPe->m_pSectionHeaders[i].Name, 8);
		memo[8] = 0;

		hSectionHeader = Append_STRUCT(name, sizeof(IMAGE_SECTION_HEADER), "IMAGE_SECTION_HEADER", &address,
			hSectionHeaders, hSectionHeader, _tree, memo);

		//
		//		|_ Name;
		//		|_ ...
		//
		hChild = Append_CHAR8("Name", pPe->m_pSectionHeaders[i].Name, &address,
			hSectionHeader, NULL, _tree);

		hChild = Append_DWORD("VirtualSize", pPe->m_pSectionHeaders[i].Misc.VirtualSize, &address,
			hSectionHeader, hChild, _tree, "ӳڴС");

		hChild = Append_DWORD("VirtualAddress", pPe->m_pSectionHeaders[i].VirtualAddress, &address,
			hSectionHeader, hChild, _tree, "RVA, ӳַƫ");

		hChild = Append_DWORD("SizeOfRawData", pPe->m_pSectionHeaders[i].SizeOfRawData, &address,
			hSectionHeader, hChild, _tree, "ԭʼļдС, FileAlignment, δʼʱΪ0");

		hChild = Append_DWORD("PointerToRawData", pPe->m_pSectionHeaders[i].PointerToRawData, &address,
			hSectionHeader, hChild, _tree, "()ļַ");

		hChild = Append_DWORD("PointerToRelocations", pPe->m_pSectionHeaders[i].PointerToRelocations, &address,
			hSectionHeader, hChild, _tree, "ضļַ");

		hChild = Append_DWORD("PointerToLinenumbers", pPe->m_pSectionHeaders[i].PointerToLinenumbers, &address,
			hSectionHeader, hChild, _tree, "кűļַ");

		hChild = Append_WORD("NumberOfRelocations", pPe->m_pSectionHeaders[i].NumberOfRelocations, &address,
			hSectionHeader, hChild, _tree, "ضС");

		hChild = Append_WORD("NumberOfLinenumbers", pPe->m_pSectionHeaders[i].NumberOfLinenumbers, &address,
			hSectionHeader, hChild, _tree, "кűС");

		//Characteristics: ݣ루ﲻУڴ
		//sectionڴ
		strcpy(memo, "[ڴ]:");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_MEM_DISCARDABLE)
			strcat(memo, "discardable;");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_MEM_NOT_CACHED)
			strcat(memo, "not cached;");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_MEM_NOT_PAGED)
			strcat(memo, "δҳ;");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_MEM_SHARED)
			strcat(memo, ";");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_MEM_EXECUTE)
			strcat(memo, "ִ;");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_MEM_READ)
			strcat(memo, ";");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_MEM_WRITE)
			strcat(memo, "д;");

		//sectionʲô
		strcat(memo, " []");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_CNT_CODE)
			strcat(memo, ";");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_CNT_INITIALIZED_DATA)
			strcat(memo, "ʼ;");
		if(pPe->m_pSectionHeaders[i].Characteristics & IMAGE_SCN_CNT_UNINITIALIZED_DATA)
			strcat(memo, "δʼ;");

		hChild = Append_DWORD("Characteristics", pPe->m_pSectionHeaders[i].Characteristics, &address,
			hSectionHeader, hChild, _tree, memo);
	}

	//
	// [5] Dummy Bytes
	//
	
	if(pPe->GetDummySize() > 0) //FileAlignment ϴDummy Bytesһڡ
	{
		sprintf(memo, "ֽ, ʹεַ FileAlignment(0x%X) ",
			pPe->m_ntHeaders.OptionalHeader.FileAlignment);

		hDummy = Append_LPVOID("dummy bytes", pPe->GetDummySize(), "LPVOID", &address,
			TVI_ROOT, hSectionHeaders, _tree, memo);
	}

	//
	// [6] SECTIONS (BODY)
	//

	hSections = Append_STRUCT("sections", pPe->GetSizeOfAllSections(), "LPVOID[]", &address,
		TVI_ROOT, NULL, _tree);

	//עm_pSectionHeaders[i].Nameû0β8ֽȫ
	//Ҫתһ£ַ֤ 0 β
	char sectName[12] = { 0 };
	for(i=0; i<pPe->GetSectionCount(); i++)
	{
		// 8 ַ
		strncpy(sectName, (LPCTSTR)pPe->m_pSectionHeaders[i].Name, 8);

		sprintf(name, "[%d]%s", i, sectName);

		hChild = Append_LPVOID(
			name, //[0].code 
			pPe->m_pSectionHeaders[i].SizeOfRawData,
			"LPVOID",
			&address,
			hSections, hChild, _tree);
	}
}

//һϵͳʱ䣬ָ
//lpSrcTime:  ʱ㣨UTCʱ䣩
//lpDestTime: ʱָ֮ıʱ䣨ʱ䣩
BOOL CBmpFileViewDlg::MyAddSeconds(const SYSTEMTIME *lpSrcTime, SYSTEMTIME *lpDestTime, int seconds)
{
	union 
	{
		FILETIME fileTime;	//ļʱ
		ULONGLONG uint64;	//64-bit unsigned integer.
	} uFileTime_UTC, uFileTime_Local;

	if(!::SystemTimeToFileTime(lpSrcTime, (LPFILETIME)&uFileTime_UTC))
		return FALSE;

	if(seconds > 0)
		uFileTime_UTC.uint64 += UInt32x32To64(seconds, 10000000);
	else
		uFileTime_UTC.uint64 -= UInt32x32To64(-seconds, 10000000);

	//UTCʱ䣬ʱʱʱȥ
	::FileTimeToLocalFileTime((LPFILETIME)&uFileTime_UTC, (LPFILETIME)&uFileTime_Local);

	return ::FileTimeToSystemTime((FILETIME*)&uFileTime_Local, lpDestTime);
}

//psd file
void CBmpFileViewDlg::FillTreeList(CPsdFile* pPsd)
{
	char memo[256];
	unsigned int address = 0;
	size_t nSize;

	HTREEITEM hFileHeader, hChild = NULL;
	
	CTreeListCtrl& _tree = this->m_wndMyTreeList.m_tree;

	hFileHeader = Append_STRUCT("fileHeader", sizeof(PSDFILEHEADER), "PSDFILEHEADER", &address, 
		TVI_ROOT, NULL, _tree);

	hChild = Append_DWORD("Signature", pPsd->m_fileHeader.Signature, &address,
		hFileHeader, hChild, _tree, "8BPS");

	hChild = Append_WORD("Version", pPsd->m_fileHeader.Version, &address,
		hFileHeader, hChild, _tree, "Ϊ1");

	hChild = Append_LPVOID("Reserved", sizeof(pPsd->m_fileHeader.Reserved), "BYTE[6]", &address,
		hFileHeader, hChild, _tree, "");

	sprintf(memo, "ͨ = %d", pPsd->m_fileHeader.Channels);
	hChild = Append_WORD("Channels", pPsd->m_fileHeader.Channels, &address,
		hFileHeader, hChild, _tree, memo);

	sprintf(memo, "ͼ߶ = %ld", pPsd->m_fileHeader.Rows);
	hChild = Append_DWORD("Rows", pPsd->m_fileHeader.Rows, &address,
		hFileHeader, hChild, _tree, memo);

	sprintf(memo, "ͼ = %ld", pPsd->m_fileHeader.Columns);
	hChild = Append_DWORD("Columns", pPsd->m_fileHeader.Columns, &address,
		hFileHeader, hChild, _tree, memo);

	sprintf(memo, "ÿͨbpp = %ld", pPsd->m_fileHeader.Depth);
	hChild = Append_WORD("Channels", pPsd->m_fileHeader.Depth, &address,
		hFileHeader, hChild, _tree, memo);

	switch(pPsd->m_fileHeader.Mode)
	{
	case 0: strcpy(memo, "Bitmap"); break;
	case 1: strcpy(memo, "Grayscale"); break;
	case 2: strcpy(memo, "Indexed"); break;
	case 3: strcpy(memo, "RGB"); break;
	case 4: strcpy(memo, "CMYK"); break;
	case 7: strcpy(memo, "Multichannel"); break;
	case 8: strcpy(memo, "Duotone"); break;
	case 9: strcpy(memo, "Lab"); break;
	default: sprintf(memo, "unknown: %ld", pPsd->m_fileHeader.Mode); break;
	}
	hChild = Append_WORD("Mode", pPsd->m_fileHeader.Mode, &address,
		hFileHeader, hChild, _tree, memo);

	//color data section
	nSize = sizeof(DWORD) + pPsd->m_colorDataSize;
	HTREEITEM hColorData = Append_STRUCT("ColorData", nSize, "section", &address, 
		TVI_ROOT, NULL, _tree);

	hChild = Append_DWORD("Length", pPsd->m_colorDataSize, &address,
			hColorData, NULL, _tree);

	if(pPsd->m_colorDataSize > 0)
	{
		hChild = Append_LPVOID("data", pPsd->m_colorDataSize, "LPVOID", &address,
			hColorData, hChild, _tree);
	}

	//resource data section
	nSize = sizeof(DWORD) + pPsd->m_resourceSize;
	HTREEITEM hResData = Append_STRUCT("ResourceData", nSize, "section", &address, 
		TVI_ROOT, NULL, _tree);

	hChild = Append_DWORD("Length", pPsd->m_resourceSize, &address,
			hResData, NULL, _tree);

	if(pPsd->m_resourceSize > 0)
	{
		hChild = Append_LPVOID("data", pPsd->m_resourceSize, "LPVOID", &address,
			hResData, hChild, _tree);
	}

	//layer data section
	nSize = sizeof(DWORD) + pPsd->m_layerDataSize;
	HTREEITEM hLayerData = Append_STRUCT("LayerData", nSize, "section", &address, 
		TVI_ROOT, NULL, _tree);

	hChild = Append_DWORD("Length", pPsd->m_layerDataSize, &address,
			hLayerData, NULL, _tree);

	if(pPsd->m_resourceSize > 0)
	{
		hChild = Append_LPVOID("data", pPsd->m_layerDataSize, "LPVOID", &address,
			hLayerData, hChild, _tree);
	}

	//image data section
	nSize = 0;
	HTREEITEM hImageData = Append_STRUCT("ImageData", nSize, "section", &address, 
		TVI_ROOT, NULL, _tree, "СһЧ");
}
