// IcoFile.h: interface for the CIcoFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ICOFILE_H__F835CEB1_1DD1_46C2_81CE_91819C284A5A__INCLUDED_)
#define AFX_ICOFILE_H__F835CEB1_1DD1_46C2_81CE_91819C284A5A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BaseFile.h"

// ico ͼһĿ¼, ע߶ȿֵڳߴС255ʱЧ
// ֵ255ҪbitmapInfoHeaderеΪ׼
typedef struct
{
	BYTE	bWidth;               // Width of the image
	BYTE	bHeight;              // Height of the image (ʵ߶)
	BYTE	bColorCount;          // Number of colors in image (0 if >=8bpp)
	BYTE	bReserved;            // Reserved
	WORD	wPlanes;              // Color Planes
	WORD	wBitCount;            // Bits per pixel
	DWORD	dwBytesInRes;         // how many bytes in this resource?
	DWORD	dwImageOffset;        // where in the file is this image
} ICONDIRENTRY, *LPICONDIRENTRY;

// ico ļͷ Ҫ̬ڴ䡣ǲȡ
//typedef struct 
//{
//	WORD			idReserved;   // Reserved
//	WORD			idType;       // resource type (1 for icons)
//	WORD			idCount;      // how many images?
//	ICONDIRENTRY	idEntries[1]; // entries for each image (idCount of 'em)
//} ICONDIR, *LPICONDIR;

// ico ļͷ2ǲȡ壬ĴСǹ̶ģΪԱ
typedef struct 
{
	WORD			idReserved;   // Reserved
	WORD			idType;       // resource type (1 for icons)
	WORD			idCount;      // how many images?
} ICONFILEHEADER, *LPICONFILEHEADER;


// icoһ֡ͼݣָ
typedef struct
{
	//ڴصϢ
	int nPaletteSize;		//ɫɫ
	int nLineSize_XOR;		//XORֵɨпȣbytes
	int nLineSize_AND;		//ANDֵɨпȣbytes
	size_t nSize_XOR;		//Сbytes
	size_t nSize_AND;

	//ڴָ룡ηڴ棬->ٷ䣩
	LPBITMAPINFO lpInfo;	//ע⣬еĸ߶ʵ߶ȵ2
	LPVOID lpXOR;			//ͼƬ
	LPVOID lpAND;			//ɫɰ
	
} ICONIMAGE, *LPICONIMAGE;

class CIcoFile : CBaseFile
{
public:
	CIcoFile();
	virtual ~CIcoFile();

private:
	WORD m_imgCount;

public:
	size_t GetSizeOfAllImages();
	size_t GetSizeOfImage(int index);
	virtual BOOL LoadFile(LPCTSTR lpszFileName);
	void Clear();
	WORD GetImgCount() { return m_imgCount; };
	ICONFILEHEADER m_fileHeader;
	LPICONDIRENTRY m_pEntries;
	LPICONIMAGE m_pImages;
};

#endif // !defined(AFX_ICOFILE_H__F835CEB1_1DD1_46C2_81CE_91819C284A5A__INCLUDED_)
