// PsdFile.h: interface for the CPsdFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PSDFILE_H__F48FF4D6_5C75_4979_9B2B_397F3E7A9C67__INCLUDED_)
#define AFX_PSDFILE_H__F48FF4D6_5C75_4979_9B2B_397F3E7A9C67__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BaseFile.h"

//עPSDļbig-endianģתΪlittle-endian
#pragma pack(push)
#pragma pack(2)
typedef struct _PSD_FILE_HEADER
{
	DWORD Signature;	//8BPS
	WORD Version;		//ԶΪ1
	BYTE Reserved[6];	//Ĭ϶2ֽ
	WORD Channels;		//ͨ1 ~ 24
	DWORD Rows;			//߶
	DWORD Columns;		//
	WORD Depth;			//ÿͨλ1816
	WORD Mode;			//ͼģʽ
} PSDFILEHEADER, *LPPSDFILEHEADER;
#pragma pack(pop)

class CPsdFile : public CBaseFile  
{
public:
	virtual BOOL LoadFile(LPCTSTR lpszFileName);
	CPsdFile();
	virtual ~CPsdFile();

public:
	PSDFILEHEADER m_fileHeader;
	DWORD m_colorDataSize;
	DWORD m_resourceSize;
	DWORD m_layerDataSize;

protected:
	DWORD htonl(DWORD val);
	WORD htons(WORD val);
};

#endif // !defined(AFX_PSDFILE_H__F48FF4D6_5C75_4979_9B2B_397F3E7A9C67__INCLUDED_)
