// TreeListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "TreeListCtrl.h"

#include "TLFrame.h"

//#include "NewTreeListCtrlView.h"
#include "windowsx.h"  // required for GET_X_LPARAM, GET_Y_LPARAM)
#include <time.h>

//#include "resource.h" //for ctl 's id;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ID_TREE_LIST_HEADER 370


/////////////////////////////////////////////////////////////////////////////
// CTLItem
//
// --------------------------------------------------------------------------
// ʹõCStringȥάsubStringsɾʱܳ쳣
// VC6MFC⡣ҲΪʹC++׼STLеstringMFCеĶ
// ãDeleteAllItemstry-catch
//
// ҰԭʹõCString滻Ϊ׼еstring󣡽CStringͷʱ
// 쳣
//
// --hoodlum1980

CTLItem::CTLItem()
{
	m_cEnding = 0x03; //ΪͨѶʹõķǴӡַETX'?';
	//m_itemString = "";
	m_itemString = "";

	m_Bold = FALSE;
	//еɫĬΪɫ
	//m_Color = ::GetSysColor(COLOR_WINDOWTEXT);

	//8λΪ0ʱʾҪ䱳ɫ
	b_hasBkColor = FALSE;
	m_BkColor = RGB(255, 255, 255);
}

CTLItem::CTLItem(CTLItem &copyItem)
{
	m_cEnding = copyItem.m_cEnding;
	//m_itemString = copyItem.GetItemString();
	m_itemString = copyItem.m_itemString;

	m_Bold = copyItem.m_Bold;
	//m_Color = copyItem.m_Color;
	//vector's operator= (copy!)
	m_Colors = copyItem.m_Colors;
	b_hasBkColor = copyItem.b_hasBkColor;
	m_BkColor = copyItem.m_BkColor;
	itemData = copyItem.itemData;
}

CString CTLItem::GetSubstring(int m_nSub)
{
	CString m_tmpStr("");
	int i=0, nHits=0;
	//int length = m_itemString.GetLength();
	int length = m_itemString.size();

	while((i<length) && (nHits <= m_nSub))
	{
		if(m_itemString[i] == m_cEnding)
		{
			nHits++;
		}
		else
		{
			if(nHits == m_nSub)
				m_tmpStr += m_itemString[i];
		}
		i++;
	}

	if((i >= length) && (nHits < m_nSub))
		return "";
	else
		return m_tmpStr;
}

void CTLItem::SetSubstring(int m_nSub, CString m_sText, COLORREF color)
{	
	CString m_tmpStr("");
	int i = 0, nHits = 0, first = 0;
	//int length = m_itemString.GetLength();
	int length = m_itemString.size();

	while((i < length) && (nHits <= m_nSub))
	{
		if(m_itemString[i] == m_cEnding)
		{
			if(nHits != m_nSub)
				first = i;
			nHits++;
		}

		i++;
	}

	//CString m_newStr("");
	string m_newStr("");
	if((nHits > m_nSub) || ((nHits == m_nSub) && (i >= length)))
	{
		// insert in the middle
		//ǰ벿
		if(first != 0)
		{
			//m_newStr = m_itemString.Left(first);
			m_newStr.append(m_itemString, 0, first);
			m_newStr += m_cEnding; 
		}
		m_newStr += (LPCTSTR)m_sText;
		//ӽβ
		if(i<length)
		{
			m_newStr += m_cEnding;
			//m_newStr += m_itemString.Right(m_itemString.GetLength()-i);
			m_newStr.append(m_itemString, i, m_itemString.size() - i);
		}

		m_itemString = m_newStr;
		m_Colors.insert(m_Colors.begin() + m_nSub, color);
	}
	else
	{
		// insert at the end
		for(i = nHits;i < m_nSub;i++)
		{
			m_itemString += m_cEnding;
			//ɫ
			m_Colors.push_back(color);
		}

		m_itemString += (LPCTSTR)m_sText;
		//m_Colors.push_back(color);
		/*
		char tmp[256];
		sprintf(tmp, "nCol: %ld, Colors.size()=%ld, RGB(%X, %X, %X)\n",
			m_nSub, m_Colors.size(), 
			GetRValue(color),
			GetGValue(color),
			GetBValue(color));
		OutputDebugString(tmp);
		*/
	}
}

COLORREF CTLItem::GetColor(int nCol) const
{
	if(nCol >= 0 && nCol < this->m_Colors.size())
		return this->m_Colors[nCol];
	else
		return ::GetSysColor(COLOR_WINDOWTEXT);
}

void CTLItem::SetColor(COLORREF newColor)
{
	int i;
	for(i = 0; i < this->m_Colors.size(); i++)
		this->m_Colors[i] = newColor;
}

/////////////////////////////////////////////////////////////////////////////
// CTreeListCtrl

CTreeListCtrl::CTreeListCtrl()
{
	m_nColumns = 0;
	m_nColumnsWidth = 0;
	m_nOffset = 0; //ˮƽйأͨǸΪλ
	m_selectedItem=NULL;
	b_GridLines = FALSE; //ǷߣĬϲƣ
	m_colorGrid = RGB(230, 232, 190);  //ǳɫ
	m_colorBkGnd = RGB(250, 254, 218); //Ĭϵɫͬtooltipɫ
}

CTreeListCtrl::~CTreeListCtrl()
{		
}


BEGIN_MESSAGE_MAP(CTreeListCtrl, CTreeCtrl)
	//{{AFX_MSG_MAP(CTreeListCtrl)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_KEYDOWN()
	ON_WM_DESTROY()	
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()	
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()	
	ON_MESSAGE(UWM_TV_CHECKBOX, OnTvCheckbox)
	ON_NOTIFY_REFLECT(NM_CLICK, OnClick)
	ON_WM_TIMER()		
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTreeListCtrl message handlers

int CTreeListCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{	
	if (CTreeCtrl::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
} 

HTREEITEM CTreeListCtrl::GetTreeItem(int nItem)
{
	HTREEITEM m_ParentItem = GetRootItem();
	int m_nCount = 0;

	while((m_ParentItem!=NULL) && (m_nCount<nItem))
	{
		m_nCount ++ ;
		GetNextSiblingItem(m_ParentItem);
	}

	return m_ParentItem;
}

int CTreeListCtrl::GetListItem(HTREEITEM hItem)
{
	HTREEITEM m_ParentItem = GetRootItem();
	int m_nCount = 0;

	while((m_ParentItem!=NULL) && (m_ParentItem!=hItem))
	{
		m_nCount ++ ;
		GetNextSiblingItem(m_ParentItem);
	}

	return m_nCount;
}

int CTreeListCtrl::InsertColumn(int nCol, LPCTSTR lpszColumnHeading, int nFormat, int nWidth, int nSubItem)
{
	HDITEM hdi;
	hdi.mask = HDI_TEXT | HDI_FORMAT;

	if(nWidth != -1)
	{
		hdi.mask |= HDI_WIDTH;
		hdi.cxy = nWidth;
	}
	
	hdi.pszText = (LPTSTR)lpszColumnHeading;
	hdi.fmt = HDF_OWNERDRAW;

	if(nFormat == LVCFMT_RIGHT)
		hdi.fmt |= HDF_RIGHT;
	else if(nFormat == LVCFMT_CENTER)
		hdi.fmt |= HDF_CENTER;
	else
		hdi.fmt |= HDF_LEFT;

	m_nColumns ++ ;

	int m_nReturn = m_wndHeader.InsertItem(nCol, &hdi);

	if(m_nColumns==1)
	{
		m_wndHeader.SetItemImage(m_nReturn, 0);
	}

	RecalcColumnsWidth();
	SetBkColor(this->m_colorBkGnd);
	return m_nReturn;
}

int CTreeListCtrl::GetColumnWidth(int nCol)
{
	HDITEM hItem;
	hItem.mask = HDI_WIDTH;
	if(!m_wndHeader.GetItem(nCol, &hItem))
		return 0;

	return hItem.cxy;
}

int CTreeListCtrl::GetColumnAlign(int nCol)
{
	HD_ITEM hItem;
	hItem.mask = HDI_FORMAT;
	if(!m_wndHeader.GetItem(nCol, &hItem))
		return LVCFMT_LEFT;

	if(hItem.fmt & HDF_RIGHT)
		return LVCFMT_RIGHT;
	else
	if(hItem.fmt & HDF_CENTER)
		return LVCFMT_CENTER;
	else
		return LVCFMT_LEFT;
}

void CTreeListCtrl::RecalcColumnsWidth()
{
	m_nColumnsWidth = 0;
	for(int i = 0;i < m_nColumns;i++)
		m_nColumnsWidth += GetColumnWidth(i);
}

void CTreeListCtrl::DrawItemText (CDC* pDC, CString text, CRect rect, int nWidth, int nFormat)
{
    //
    // Make sure the text will fit in the prescribed rectangle, and truncate
    // it if it won't.
    //
    BOOL bNeedDots = FALSE;
    int nMaxWidth = nWidth - 4;

    while ((text.GetLength()>0) && (pDC->GetTextExtent((LPCTSTR) text).cx > (nMaxWidth - 6))) {
        text = text.Left (text.GetLength () - 1);
        bNeedDots = TRUE;
    }

    if (bNeedDots) {
        if (text.GetLength () >= 1)
            text = text.Left (text.GetLength () - 1);
        text += "...";
    }

    //
    // Draw the text into the rectangle using MFC's handy CDC::DrawText
    // function.
    //
    rect.right = rect.left + nMaxWidth;

    UINT nStyle = DT_VCENTER | DT_SINGLELINE;
    if (nFormat == LVCFMT_LEFT)
        nStyle |= DT_LEFT;
    else if (nFormat == LVCFMT_CENTER)
        nStyle |= DT_CENTER;
    else 
        nStyle |= DT_RIGHT;

	if((text.GetLength()>0) && (rect.right>rect.left))
		pDC->DrawText (text, rect, nStyle);
}

void CTreeListCtrl::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClip, rcClient;
	dc.GetClipBox( &rcClip );
	GetClientRect(&rcClient);

	// Set clip region to be same as that in paint DC
	CRgn rgn;
	rgn.CreateRectRgnIndirect( &rcClip );
	dc.SelectClipRgn(&rgn);
	rgn.DeleteObject();
	
	//ɫ

	dc.SetViewportOrg(m_nOffset, 0);
	dc.SetTextColor(this->m_colorBkGnd);

	//һСȱݣԭTreeControlṩṹۣ
	//ﲻеıɫչؼࡣ

	// First let the control do its default drawing.
	CWnd::DefWindowProc( WM_PAINT, (WPARAM)dc.m_hDC, 0 );	

	//ƱҲʹͼƬ
	dc.FillSolidRect(GetColumnWidth(0), 1, rcClient.Width(), rcClient.Height(),
		this->m_colorBkGnd);

	CTLItem *pItem;
	
	//HTREEITEM hItem = GetFirstVisibleItem();
	//int n = GetVisibleCount();
	

	/* һǿԲҪˡ
	// the most urgent thing is to erase the labels that were drawn by the tree
	while(hItem!=NULL && n>=0)
	{
		CRect rect;

		UINT selflag = TVIS_DROPHILITED | TVIS_SELECTED;
	
		CRect m_labelRect;
		GetItemRect( hItem, &m_labelRect, TRUE );
		GetItemRect( hItem, &rect, FALSE );
		if(GetColumnsNum()>1)
			rect.left = min(m_labelRect.left, GetColumnWidth(0));
		else
			rect.left = m_labelRect.left;
		rect.right = m_nColumnsWidth;

		//dc.FillSolidRect(rect.left,rect.top, rect.Width(),rect.Height(),
		//	this->m_colorBkGnd);

		hItem = GetNextVisibleItem( hItem );
		n--;
	}
	*/

	// create the font
	CFont *pFontDC;
	CFont fontDC, boldFontDC;
	LOGFONT logfont;

	CFont *pFont = GetFont();
	pFont->GetLogFont( &logfont );

	fontDC.CreateFontIndirect( &logfont );
	pFontDC = dc.SelectObject( &fontDC );

	logfont.lfWeight = 700;
	boldFontDC.CreateFontIndirect( &logfont );

	BOOL bSelected = FALSE;
	COLORREF color_highlight_text = ::GetSysColor (COLOR_HIGHLIGHTTEXT);
	COLORREF color_highlight = ::GetSysColor(COLOR_HIGHLIGHT);
	CBrush brush_highlight(color_highlight);
	CBrush brush_normal(this->m_colorBkGnd); //m_colorBkGnd);

	CPen *def_pen = NULL;
	CPen pen_grid;
	POINT grid_from, grid_to;
	
	if(this->b_GridLines)
	{
		pen_grid.CreatePen(PS_SOLID, 1, this->m_colorGrid);
		def_pen = dc.SelectObject(&pen_grid);
	}		

	// and now let's get to the painting itself

	HTREEITEM hItem = GetFirstVisibleItem();
	int n = GetVisibleCount();
	int m_nWidth;
	
	//ΪѡУ
	dc.SetBkMode(TRANSPARENT);
	
	while(hItem != NULL && n >= 0)
	{
		CRect rect;

		UINT selflag = TVIS_DROPHILITED | TVIS_SELECTED;
	
		//ǷѡУ
		bSelected = GetItemState(hItem, selflag) & selflag;

		pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
		CString sItem = pItem->GetItemText();


		CRect m_labelRect;
		GetItemRect(hItem, &m_labelRect, TRUE);
		GetItemRect(hItem, &rect, FALSE);
		
		//һأڵĻƣ
		grid_from.x = rect.left;
		grid_from.y = rect.bottom - 1;
		grid_to.y = grid_from.y;

		if(GetColumnsNum() > 1)
		{
			grid_to.x = GetColumnWidth(0) - 1;				
			rect.left = min(m_labelRect.left, GetColumnWidth(0));
		}
		else
		{
			grid_to.x = m_nColumnsWidth - 1;
			rect.left = m_labelRect.left;
		}

		//Ƿɫɫcellڲ
		rect.right = m_nColumnsWidth - 1;

		//һǱѡеģôǻɫͽ
		if(bSelected)
		{
			rect.bottom--;
			dc.FillRect(rect, &brush_highlight);
			rect.bottom++;
			//û GridLines ʱŻƽΣ
			if(!this->b_GridLines)
				dc.DrawFocusRect(rect);

			//dc.SetBkColor(color_highlight);
			dc.SetTextColor(color_highlight_text);
		}
		else
		{
			//ñɫ䣨ˮƽԺ󣬿ԷֹлѡʱҲвɫ
			//ע͵һFillRect룬ⲻǺܴ󣬵С覴ã
			//ڵһȡѡʱһСɫûб
			if(pItem->b_hasBkColor)
			{
				dc.FillSolidRect(&rect, pItem->m_BkColor);
			}
			else
				dc.FillRect(rect, &brush_normal);
			//dc.SetBkColor(this->m_colorBkGnd);

			//һı
			dc.SetTextColor(pItem->GetColor(0));

		}
		if(pItem->m_Bold) //ǷǴ壿
		{
			dc.SelectObject(&boldFontDC);
		}

		//Ƶһӵı
		DrawItemText(&dc, sItem, CRect(rect.left + 2, rect.top, GetColumnWidth(0), rect.bottom), GetColumnWidth(0)-rect.left-2, GetColumnAlign(0));
		//Ƶһӵ½ "______|"
		if(this->b_GridLines)
		{
			dc.MoveTo(grid_from.x, grid_from.y);
			dc.LineTo(grid_to.x, grid_to.y);

			grid_to.y = rect.top - 1;
			dc.LineTo(grid_to.x, grid_to.y);
		}

		m_nWidth = 0;
		for(int i = 1; i < m_nColumns; i++)
		{
			if(!bSelected)
				dc.SetTextColor(pItem->GetColor(i));

			m_nWidth += GetColumnWidth(i - 1);
			DrawItemText(&dc, pItem->GetSubstring(i), CRect(m_nWidth + 2, rect.top, m_nWidth + GetColumnWidth(i), rect.bottom), GetColumnWidth(i), GetColumnAlign(i));
			if(this->b_GridLines)
			{
				grid_from.x = grid_to.x;
				grid_from.y = rect.bottom - 1;
				grid_to.x = grid_from.x + GetColumnWidth(i);// - 1;
				grid_to.y = grid_from.y;
					
				//ƸӵĵײԵ
				dc.MoveTo(grid_from.x, grid_from.y);
				dc.LineTo(grid_to.x, grid_to.y);

				//ƸҲԵ
				grid_to.y = rect.top - 1;
				dc.LineTo(grid_to.x, grid_to.y);
			}
		}			
		//dc.SetTextColor(::GetSysColor (COLOR_WINDOWTEXT ));
		if(pItem->m_Bold)
		{
			dc.SelectObject( &fontDC );
		}
		hItem = GetNextVisibleItem( hItem );
		n--;
	}
	dc.SelectObject( pFontDC );
	if(def_pen != NULL)
		dc.SelectObject(def_pen);
}

void CTreeListCtrl::ResetVertScrollBar()
{
	CTLFrame *pFrame = (CTLFrame*)GetParent();

	CRect m_treeRect;
	GetClientRect(&m_treeRect);

	CRect m_wndRect;
	pFrame->GetClientRect(&m_wndRect);

	CRect m_headerRect;
	m_wndHeader.GetClientRect(&m_headerRect);	

	CRect m_barRect;
	pFrame->m_horScrollBar.GetClientRect(&m_barRect);

	if(!pFrame->HorizontalScrollVisible())
		SetWindowPos(&wndTop, 0, 0, m_wndRect.Width(), m_wndRect.Height()-m_headerRect.Height(), SWP_NOMOVE);
	else
		SetWindowPos(&wndTop, 0, 0, m_wndRect.Width(), m_wndRect.Height()-m_barRect.Height()-m_headerRect.Height(), SWP_NOMOVE);

	if(pFrame->HorizontalScrollVisible())
	{
		if(!pFrame->VerticalScrollVisible())
		{
			pFrame->m_horScrollBar.SetWindowPos(&wndTop, 0, 0, m_wndRect.Width(), m_barRect.Height(), SWP_NOMOVE);
			
			int nMin, nMax;
			pFrame->m_horScrollBar.GetScrollRange(&nMin, &nMax);
			if((nMax-nMin) == (GetColumnsWidth()-m_treeRect.Width()+GetSystemMetrics(SM_CXVSCROLL)))
				// i.e. it disappeared because of calling
				// SetWindowPos
			{
				if(nMax - GetSystemMetrics(SM_CXVSCROLL) > 0)
					pFrame->m_horScrollBar.SetScrollRange(nMin, nMax - GetSystemMetrics(SM_CXVSCROLL));
				else
					// hide the horz scroll bar and update the tree
				{
					pFrame->m_horScrollBar.EnableWindow(FALSE);

					// we no longer need it, so hide it!
					{
						pFrame->m_horScrollBar.ShowWindow(SW_HIDE);

						SetWindowPos(&wndTop, 0, 0, m_wndRect.Width(), m_wndRect.Height() - m_headerRect.Height(), SWP_NOMOVE);
						// the tree takes scroll's place
					}

					pFrame->m_horScrollBar.SetScrollRange(0, 0);

					// set scroll offset to zero
					{
						m_nOffset = 0;
						Invalidate();
						m_wndHeader.GetWindowRect(&m_headerRect);
						m_wndHeader.SetWindowPos(&wndTop, m_nOffset, 0, max(pFrame->StretchWidth(GetColumnsWidth(),m_wndRect.Width()),m_wndRect.Width()), m_headerRect.Height(), SWP_SHOWWINDOW);
					}
				}
			}
		}
		else
		{
			pFrame->m_horScrollBar.SetWindowPos(&wndTop, 0, 0, m_wndRect.Width() - GetSystemMetrics(SM_CXVSCROLL), m_barRect.Height(), SWP_NOMOVE);

			int nMin, nMax;
			pFrame->m_horScrollBar.GetScrollRange(&nMin, &nMax);
			if((nMax-nMin) == (GetColumnsWidth()-m_treeRect.Width()-GetSystemMetrics(SM_CXVSCROLL)))
				// i.e. it appeared because of calling
				// SetWindowPos
			{
				pFrame->m_horScrollBar.SetScrollRange(nMin, nMax + GetSystemMetrics(SM_CXVSCROLL));
			}
		}
	}
	else
	if(pFrame->VerticalScrollVisible())
	{
		if(GetColumnsWidth()>m_treeRect.Width())
			// the vertical scroll bar takes some place
			// and the columns are a bit bigger than the client
			// area but smaller than (client area + vertical scroll width)
		{
			// show the horz scroll bar
			{
				pFrame->m_horScrollBar.EnableWindow(TRUE);

				pFrame->m_horScrollBar.ShowWindow(SW_SHOW);

				// the tree becomes smaller
				SetWindowPos(&wndTop, 0, 0, m_wndRect.Width(), m_wndRect.Height()-m_barRect.Height()-m_headerRect.Height(), SWP_NOMOVE);

				pFrame->m_horScrollBar.SetWindowPos(&wndTop, 0, 0, m_wndRect.Width() - GetSystemMetrics(SM_CXVSCROLL), m_barRect.Height(), SWP_NOMOVE);
			}

			pFrame->m_horScrollBar.SetScrollRange(0, GetColumnsWidth()-m_treeRect.Width());
		}
	}
}

//µʱǵˡ+-棬ҪлѡеItem
void CTreeListCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{	
	UINT flags;
	//BOOL bRestore = FALSE;
	HTREEITEM hCurSel = this->GetSelectedItem();

	//ƫ
	CPoint _pt;
	_pt.x = point.x - this->m_nOffset;
	_pt.y = point.y;
	m_selectedItem = this->HitTest(_pt, &flags);

	//CString str;
	//str.Format("%08X, m_nOffset: %d", flags, this->m_nOffset);
	//AfxMessageBox(str);

	//ԵĽֵ
	//TVHT_NOWHERE       0x0001 ռĿհ״нڵ·Ŀͻ
	//TVHT_ONITEMICON    0x0002 ڵԶͼͼƬ
	//TVHT_ONITEMLABEL   0x0004 ڵֱǩڴ˴˫չ۵ڵ㣡
	//TVHT_ONITEMINDENT  0x0008	ڵλ(+-֮ǰĿհ)
	//TVHT_ONITEMBUTTON  0x0010	ڵǰ+-
	//TVHT_ONITEMRIGHT   0x0020 ڵҲհףıĿհף

	//+-ťϵڽڵҲҪıѡнڵ
	if(flags & TVHT_ONITEMBUTTON)
	{
		//bRestore = TRUE;
		//toggle the node
		this->Expand(m_selectedItem, TVE_TOGGLE);
	}
	else if(flags & TVHT_ONITEMRIGHT)
	{
		//bRestore = TRUE;
		//Ҳ࣬ʲôҲҪ
	}
	else
	{
		if(//(flags & TVHT_ONITEMRIGHT) 
			 (flags & TVHT_ONITEMINDENT)  //
			|| (flags & TVHT_ONITEM))
		{
			SelectItem(m_selectedItem);
		}
	}	
	// CTreeCtrl::OnLButtonDown(nFlags, _pt);
	//if(bRestore)
	//{
	//	m_selectedItem = hCurSel;
	//	SelectItem(hCurSel);
	//}
}

void CTreeListCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	//ԵĽֵ
	//TVHT_NOWHERE       0x0001 ռĿհ״нڵ·Ŀͻ
	//TVHT_ONITEMICON    0x0002 ڵԶͼͼƬ
	//TVHT_ONITEMINDENT  0x0008	ڵλ(+-֮ǰĿհ)
	//TVHT_ONITEMBUTTON  0x0010	ڵǰ+-
	//TVHT_ONITEMRIGHT   0x0020 ڵҲհףıĿհף
	UINT flags;
	//HTREEITEM hCurSel = this->GetSelectedItem();
	//BOOL bRestore = FALSE;
	//ƫ
	CPoint _pt;
	_pt.x = point.x - this->m_nOffset;
	_pt.y = point.y;

	m_selectedItem = HitTest(_pt, &flags);

	//CString str;
	//str.Format("%08X, m_nOffset: %d", flags, this->m_nOffset);
	////AfxMessageBox(str);
	//this->GetParent()->GetParent()->SetDlgItemText(IDC_STATIC_STATUS, str);

	//if((flags & TVHT_ONITEMBUTTON) || (flags & TVHT_ONITEMRIGHT))
	//{
	//	bRestore = TRUE;
	//}
	//else
	//{
	//	//SelectItem(m_selectedItem);
	//}

	//CTreeCtrl::OnLButtonUp(nFlags, _pt);
	
	//if(bRestore)
	//{
	//	m_selectedItem = hCurSel;
	//	SelectItem(hCurSel);
	//}
}

void CTreeListCtrl::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	UINT flags;
	//ƫ
	CPoint _pt;
	_pt.x = point.x - this->m_nOffset;
	_pt.y = point.y;

	HTREEITEM hItem = this->HitTest(_pt, &flags);
	//if((GetColumnsNum() == 0 ) || (point.x < GetColumnWidth(0)))
	//{
	//	CTreeCtrl::OnLButtonDblClk(nFlags, point);
	//	ResetVertScrollBar();
	//}
	//ƭؼ˫˽ڵǩ
	if(hItem != NULL)
	{
		if((flags & TVHT_ONITEMLABEL) || (flags & TVHT_ONITEMICON))
			this->Expand(hItem, TVE_TOGGLE); //ıڵ״̬
		
		//CTreeCtrl::OnLButtonDblClk(nFlags, newPt);
		//ResetVertScrollBar();
	}
	else
	{
		//CTreeCtrl::OnLButtonDblClk(nFlags, _pt);
		//ResetVertScrollBar();
	}
	SetFocus();
}

void CTreeListCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CTreeCtrl::OnKeyDown(nChar, nRepCnt, nFlags);
	ResetVertScrollBar();
	m_selectedItem=GetSelectedItem();	
}

BOOL CTreeListCtrl::SetItemData(HTREEITEM hItem, DWORD dwData)
{
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
	if(!pItem)
		return FALSE;
	pItem->itemData = dwData;
	return CTreeCtrl::SetItemData(hItem, (LPARAM)pItem);
}

DWORD CTreeListCtrl::GetItemData(HTREEITEM hItem) const
{
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
	if(!pItem)
		return NULL;
	return pItem->itemData;
}				

HTREEITEM CTreeListCtrl::InsertItem(LPCTSTR lpszItem, HTREEITEM hParent, HTREEITEM hInsertAfter)
{	
	CTLItem *pItem = new CTLItem;
	pItem->InsertItem(lpszItem);
	m_nItems++;
	((CTLFrame*)GetParent())->ResetScrollBar();
	
	return CTreeCtrl::InsertItem(TVIF_PARAM|TVIF_TEXT, "", 0, 0, 0, 0, (LPARAM)pItem, hParent, hInsertAfter);
}

HTREEITEM CTreeListCtrl::InsertItem( LPCTSTR lpszItem, int nImage, int nSelectedImage, HTREEITEM hParent, HTREEITEM hInsertAfter)
{
	CTLItem *pItem = new CTLItem;
	pItem->InsertItem(lpszItem);
	m_nItems++;
	((CTLFrame*)GetParent())->ResetScrollBar();
	
	return CTreeCtrl::InsertItem(TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE, "", nImage, nSelectedImage, 0, 0, (LPARAM)pItem, hParent, hInsertAfter);
}

HTREEITEM CTreeListCtrl::InsertItem(UINT nMask, LPCTSTR lpszItem, int nImage, int nSelectedImage, UINT nState, UINT nStateMask, LPARAM lParam, HTREEITEM hParent, HTREEITEM hInsertAfter )
{
	CTLItem *pItem = new CTLItem;
	pItem->InsertItem(lpszItem);
	pItem->itemData = lParam;
	m_nItems++;
	((CTLFrame*)GetParent())->ResetScrollBar();	
	
	return CTreeCtrl::InsertItem(nMask, "", nImage, nSelectedImage, nState, nStateMask, (LPARAM)pItem, hParent, hInsertAfter); 
}


HTREEITEM CTreeListCtrl::CopyItem(HTREEITEM hItem, HTREEITEM hParent, HTREEITEM hInsertAfter)
{	
	if(ItemHasChildren(hItem))
		return NULL;
	
	TV_ITEM item;
	item.mask = TVIF_IMAGE | TVIF_PARAM | TVIF_SELECTEDIMAGE | TVIF_STATE | TVIF_TEXT;
	item.hItem = hItem;	
	GetItem(&item);
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
	CTLItem *pNewItem = new CTLItem(*pItem);

	item.lParam = (LPARAM)pNewItem;

	TV_INSERTSTRUCT insStruct;
	insStruct.item = item;
	insStruct.hParent = hParent;
	insStruct.hInsertAfter = hInsertAfter;	
	
	return CTreeCtrl::InsertItem(&insStruct);
}

HTREEITEM CTreeListCtrl::MoveItem(HTREEITEM hItem, HTREEITEM hParent, HTREEITEM hInsertAfter)
{
	if(ItemHasChildren(hItem))
		return NULL;
		
	TV_ITEM item;
	item.mask = TVIF_IMAGE | TVIF_PARAM | TVIF_SELECTEDIMAGE | TVIF_STATE | TVIF_TEXT;
	item.hItem = hItem;	
	GetItem(&item);
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
	CTLItem *pNewItem = new CTLItem(*pItem);
	DeleteItem(hItem);
	
	item.lParam = (LPARAM)pNewItem;

	TV_INSERTSTRUCT insStruct;	
	insStruct.item = item;
	insStruct.hParent = hParent;
	insStruct.hInsertAfter = hInsertAfter;
	

	return CTreeCtrl::InsertItem(&insStruct);
}

BOOL CTreeListCtrl::SetItemText(HTREEITEM hItem, int nCol ,LPCTSTR lpszItem, COLORREF color)
{
	CTLItem *pItem = (CTLItem*)CTreeCtrl::GetItemData(hItem);
	if(!pItem)
		return FALSE;
	pItem->SetSubstring(nCol, lpszItem, color);
	return CTreeCtrl::SetItemData(hItem, (LPARAM)pItem);
}

//ĳһеɫǰ
BOOL CTreeListCtrl::SetItemColor(HTREEITEM hItem, COLORREF m_newColor, BOOL m_bInvalidate )
{
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
	if(!pItem)
		return FALSE;

	pItem->SetColor(m_newColor);

	if(!CTreeCtrl::SetItemData(hItem, (LPARAM)pItem))
		return FALSE;
	if(m_bInvalidate)
		Invalidate();
	return TRUE;	
}

//ĳһеɫ
BOOL CTreeListCtrl::SetItemBkColor(HTREEITEM hItem, BOOL hasBkColor, COLORREF m_newColor, BOOL m_bInvalidate )
{
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
	if(!pItem)
		return FALSE;
	pItem->b_hasBkColor = hasBkColor;
	pItem->m_BkColor = m_newColor;
	if(!CTreeCtrl::SetItemData(hItem, (LPARAM)pItem))
		return FALSE;
	if(m_bInvalidate)
		Invalidate();
	return TRUE;	
}

//ĳһǷΪʾ
BOOL CTreeListCtrl::SetItemBold( HTREEITEM hItem, BOOL m_Bold, BOOL m_bInvalidate )
{
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
	if(!pItem)
		return FALSE;
	pItem->m_Bold = m_Bold;
	if(!CTreeCtrl::SetItemData(hItem, (LPARAM)pItem))
		return FALSE;
	if(m_bInvalidate)
		Invalidate();
	return TRUE;
}

//ĳڵ㣨УĳsubItemı
CString CTreeListCtrl::GetItemText( HTREEITEM hItem, int nSubItem )
{
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
		
	if(!pItem)
		return _T("");
	return pItem->GetSubstring(nSubItem);
}

CString CTreeListCtrl::GetItemText( int nItem, int nSubItem )
{
	return GetItemText(GetTreeItem(nItem), nSubItem);
}

BOOL CTreeListCtrl::DeleteItem( HTREEITEM hItem )
{
	CTLItem *pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
	if(!pItem)
		return FALSE;
	
	m_nItems --;
	
	return CTreeCtrl::DeleteItem(hItem);
}

BOOL CTreeListCtrl::DeleteItem( int nItem )
{
	return DeleteItem(GetTreeItem(nItem));
}

int CALLBACK CTreeListCtrl::CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CTLItem *pItem1 = (CTLItem *)lParam1;
	CTLItem *pItem2 = (CTLItem *)lParam2;
	
	SSortType *pSortType = (SSortType *)lParamSort;

	CString str1 = pItem1->GetSubstring(pSortType->nCol);
	CString str2 = pItem2->GetSubstring(pSortType->nCol);
	
	int m_nComp;
	// compare the two strings, but
	// notice:
	// in this case, "xxxx10" comes after "xxxx2"
	{
		CString tmpStr1, tmpStr2;
		int index = str1.FindOneOf("0123456789");
		if(index!=-1)
			tmpStr1 = str1.Right(str1.GetLength()-index);
		index = str2.FindOneOf("0123456789");
		if(index!=-1)
			tmpStr2 = str2.Right(str2.GetLength()-index);
		
		tmpStr1 = tmpStr1.SpanIncluding("0123456789");
		tmpStr2 = tmpStr2.SpanIncluding("0123456789");

		if((tmpStr1=="") && (tmpStr2==""))
			m_nComp = str1.CompareNoCase(str2);
		else
		{
			int num1 = atoi(tmpStr1);
			int num2 = atoi(tmpStr2);

			tmpStr1 = str1.SpanExcluding("0123456789");
			tmpStr2 = str2.SpanExcluding("0123456789");

			if(tmpStr1 == tmpStr2)
			{
				if(num1 > num2)
					m_nComp = 1;
				else
				if(num1 < num2)
					m_nComp = -1;
				else
					m_nComp = str1.CompareNoCase(str2);
			}
			else
				m_nComp = str1.CompareNoCase(str2);			
		}
	}

	if(!pSortType->bAscending)
	{
		if(m_nComp == 1)
			m_nComp = -1;
		else
		if(m_nComp == -1)
			m_nComp = 1;
	}

	return m_nComp;
}

//ĳһн򣨰ĸ˳򣬴СдУ
BOOL CTreeListCtrl::SortItems( int nCol, BOOL bAscending, HTREEITEM low)
{
	TV_SORTCB tSort;

	tSort.hParent = low;	
	tSort.lpfnCompare = CompareFunc;

	SSortType *pSortType = new SSortType;
	pSortType->nCol = nCol;
	pSortType->bAscending = bAscending;
	tSort.lParam = (LPARAM)pSortType;
	
	BOOL m_bReturn = SortChildrenCB(&tSort);
	
	delete pSortType;	
		
	return m_bReturn;
}

void CTreeListCtrl::MemDeleteAllItems(HTREEITEM hParent)
{
	HTREEITEM hItem = hParent;	
	CTLItem *pItem;	
	
	while(hItem!=NULL)
	{			
		pItem = (CTLItem *)CTreeCtrl::GetItemData(hItem);
		MemItemArray.Add(pItem);
		
		if(ItemHasChildren(hItem))
			MemDeleteAllItems(GetChildItem(hItem));			
				
		hItem = GetNextSiblingItem(hItem);		
	}	
}

//ɾнڵ㣨У
BOOL CTreeListCtrl::DeleteAllItems()
{
	LockWindowUpdate();
	BeginWaitCursor();
	
	//try catch--by hoodlum1980
	//ɾTLItemʱ򣬻~CString()쳣
	//try-catch
	try
	{
		//ռеĽڵ
		MemDeleteAllItems(GetRootItem());

		for (int i = 0;i < MemItemArray.GetSize(); i++)
			delete MemItemArray.GetAt(i);
		MemItemArray.RemoveAll();
	}
	catch(CException* ex)
	{
		// Handle the exception here.
		// ôɾܻ쳣
		// "e" contains information about the exception.
		ex->Delete();
	}
	BOOL m_bReturn = CTreeCtrl::DeleteAllItems();

	EndWaitCursor();
	UnlockWindowUpdate();
	return m_bReturn;
}

void CTreeListCtrl::OnDestroy()
{	
	MemDeleteAllItems(GetRootItem());		
	CTreeCtrl::DeleteAllItems();
	for (int i = 0;i < MemItemArray.GetSize();i++)
		delete MemItemArray.GetAt(i);
	MemItemArray.RemoveAll();

	CTreeCtrl::OnDestroy();
}

BOOL CTreeListCtrl::DeleteSubItems( HTREEITEM hItem )
{
  HTREEITEM hChild(0);
  BOOL bRet(false), bErr(false);

  while(ItemHasChildren(hItem)){
    hChild = GetChildItem(hItem);
    if (ItemHasChildren(hChild)){
      DeleteSubItems(hChild);
    }
    bRet = DeleteItem(hChild);
    if (!bRet){
      bErr = true;
    }
  }
  return bErr;
}

void CTreeListCtrl::OnRButtonDown(UINT nFlags, CPoint point) 
{	
	// find what item is selected
	
	//ӵĴǶˮƽƫƵĿǡ--hoodlum1980
	CPoint _pt;
	_pt.x = point.x - this->m_nOffset;
	_pt.y = point.y;

	m_selectedItem = HitTest(_pt, &nFlags);
	
	if((nFlags & TVHT_ONITEMRIGHT) || (nFlags & TVHT_ONITEMINDENT) ||
	   (nFlags & TVHT_ONITEM))
	{
		SelectItem(m_selectedItem);
	}	

	//CTreeCtrl::OnRButtonDown(nFlags, _pt);
}

//ԭƶԶչڵĶʱûʲôã
//ҰѰװʱܸȥͬʱˮƽƫ
//--hoodlum1980
void CTreeListCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{	
	SetFocus();
	
	//ԭTreeCtrlֻ+-Żڿӵ״̬
	//TreeCtrlĴֱһĴڣҲҪֱתκϢ

	//CPoint _pt;
	//_pt.x = point.x - this->m_nOffset;
	//_pt.y = point.y;

	//if ( m_nHoverTimerID )
	//{
	//	KillTimer( m_nHoverTimerID );
	//	m_nHoverTimerID = 0;
	//}	
		
	//// sets counter to expand if hovered over item for a while
	//m_nHoverTimerID = SetTimer(2, 750, NULL);		
		
	//CTreeCtrl::OnMouseMove(nFlags, _pt);
}


CString CTreeListCtrl::GetNextLine(CString &message)
{
CString result;
BOOL bOK = FALSE;
char k = 13;
char j;
int nSize = message.GetLength();
int nIndex = 0;
	
	//Search for the return character in the string
	while(nIndex < nSize && !bOK)
	{
		j = message.GetAt(nIndex);
		if(j == k)
		{
			result = message.Left(nIndex);
			//Drop the carriage return and line feed characters
			message = message.Right(nSize - (nIndex + 2));
			bOK = TRUE;
		}
		nIndex++;
	}
	return result;
}


void CTreeListCtrl::OnClick(NMHDR* pNMHDR, LRESULT* pResult) 
{

  DWORD dw = GetMessagePos();                   // retrieve mouse cursor position when msg was sent
  CPoint p(GET_X_LPARAM(dw), GET_Y_LPARAM(dw)); // ..and put into point structure
  ScreenToClient(&p);                    // make coords local to tree client area

  UINT htFlags = 0;
  HTREEITEM it = HitTest(p, &htFlags);   // See where the click was on

  if (it != NULL && htFlags==TVHT_ONITEMSTATEICON) {   
    // the check box was hit.
    // we just post a message
    PostMessage(UWM_TV_CHECKBOX, pNMHDR->idFrom, (LPARAM) it);
  }
	
  *pResult = 0;
}


// ----- Handle checkbox changed here! ------
LRESULT CTreeListCtrl::OnTvCheckbox(WPARAM wp, LPARAM lp)
{  
/*  HTREEITEM hParent;
  HTREEITEM CurrentChild;
 
  HTREEITEM hitem = (HTREEITEM) lp;
  // get what state the checkbox is in
  int checked = (GetItemState(hitem, TVIS_STATEIMAGEMASK) >> 12) - 1;
  
  
	 HTREEITEM TempSelected=hitem;
	  hParent=GetParentItem(hitem);
	  
	  if (checked==1)		
	  {
	  	  SetItemState(hitem,INDEXTOSTATEIMAGEMASK(3), TVIS_STATEIMAGEMASK);	  		  
	  }
*/
  
  return 0;
}

//ڿؼʱ᲻ϵ°װʱ
//ԶѱĽڵչܺͷգMouseMove
//ȥܡ--hoodlum1980
void CTreeListCtrl::OnTimer(UINT nIDEvent) 
{
	if ( nIDEvent == m_nHoverTimerID )
	{
		KillTimer( m_nHoverTimerID );
		m_nHoverTimerID = 0;

		if ( m_selectedItem )
		{
			SelectItem( m_selectedItem );
			Expand(m_selectedItem,TVE_EXPAND);	
		}
	}
	else
	{
		CTreeCtrl::OnTimer(nIDEvent);
	}
}

HTREEITEM CTreeListCtrl::HitTest(CPoint pt, UINT* pFlags)
{
	//ע⣬ҪƫֵOnнƫ

	//ԵĽֵ
	//TVHT_NOWHERE       0x0001 ռĿհ״нڵ·Ŀͻ
	//TVHT_ONITEMICON    0x0002 ڵԶͼͼƬ
	//TVHT_ONITEMLABEL   0x0004 ڵֱǩڴ˴˫չ۵ڵ㣡
	//TVHT_ONITEMINDENT  0x0008	ڵλ(+-֮ǰĿհ)
	//TVHT_ONITEMBUTTON  0x0010	ڵǰ+-
	//TVHT_ONITEMRIGHT   0x0020 ڵҲհףıĿհף

	HTREEITEM hResult = CTreeCtrl::HitTest(pt, pFlags);
	
	//ڱTreeCtrlҲƫƣԿܵ²ԽΪNULL
	//ĴаѵٴƶTreeCtrlڲȥ⡣
	if(*pFlags == TVHT_TORIGHT)
	{
		//ؼҲԵʱǻҪѵؼٴμ⣡
		pt.x = pt.x + this->m_nOffset;
		hResult = CTreeCtrl::HitTest(pt, pFlags);
		if(pt.x - this->m_nOffset <= GetColumnsWidth())
		{
			*pFlags = TVHT_ONITEMLABEL; //ƭߣLabel
		}
	}
	else if(*pFlags == TVHT_ONITEMRIGHT)
	{
		//TreeCtrlΪҲ࣬Ҫƭ
		if(pt.x <= GetColumnsWidth())
		{
			*pFlags = TVHT_ONITEMLABEL; //ƭߣLabel
		}
	}
	return hResult;
}

HTREEITEM CTreeListCtrl::HitTest(TVHITTESTINFO* pHitTestInfo)
{
	HTREEITEM hResult = CTreeCtrl::HitTest(pHitTestInfo);
	//TreeCtrlΪҲ࣬Ҫƭ

	//TVHT_TORIGHT            0x0400 : ڿؼҲ
	//˵ƫƣԿܷTVHT_TORIGHTĽ

	if(pHitTestInfo->flags == TVHT_TORIGHT)
	{
		//ؼҲԵʱǻҪѵؼٴμ⣡
		pHitTestInfo->pt.x = pHitTestInfo->pt.x + this->m_nOffset;
		hResult = CTreeCtrl::HitTest(pHitTestInfo);
		if(pHitTestInfo->pt.x - this->m_nOffset <= GetColumnsWidth())
		{
			pHitTestInfo->flags = TVHT_ONITEMLABEL; //ƭߣLabel
		}
	}
	else if(pHitTestInfo->flags == TVHT_ONITEMRIGHT )
	{
		if(pHitTestInfo->pt.x <= GetColumnsWidth())
		{
			pHitTestInfo->flags = TVHT_ONITEMLABEL; //ƭߣLabel
		}
	}	
	return hResult;
}

//ǰѱTreeViewñɫͬʱǵĳԱԻ棩Ҳõ
void CTreeListCtrl::SetBkColor(COLORREF clr)
{
	this->m_colorBkGnd = clr;
	CTreeCtrl::SetBkColor(clr);
}


