// PsdFile.cpp: implementation of the CPsdFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BmpFileView.h"
#include "PsdFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPsdFile::CPsdFile()
{

}

CPsdFile::~CPsdFile()
{

}

//Winsock2.hеֽת
//תֽ
WORD CPsdFile::htons(WORD val)
{
	return ((val & 0xff)<<8) + (val>>8);
}

//ת4ֽڵ
DWORD CPsdFile::htonl(DWORD val)
{
	return ((val & 0x000000ff) << 24) 
		+ ((val & 0x0000ff00) << 8)
		+ ((val & 0x00ff0000) >> 8)
		+ (val >> 24);
}

BOOL CPsdFile::LoadFile(LPCTSTR lpszFileName)
{
	CFile file;
	if(file.Open(lpszFileName, CFile::modeRead))
	{
		file.Read(&m_fileHeader, sizeof(m_fileHeader));
		//תֽ
		m_fileHeader.Signature = htonl(m_fileHeader.Signature);
		m_fileHeader.Version = htons(m_fileHeader.Version);
		m_fileHeader.Channels = htons(m_fileHeader.Channels);
		m_fileHeader.Rows = htonl(m_fileHeader.Rows);
		m_fileHeader.Columns = htonl(m_fileHeader.Columns);
		m_fileHeader.Depth = htons(m_fileHeader.Depth);
		m_fileHeader.Mode = htons(m_fileHeader.Mode);

		//color data section
		file.Read(&m_colorDataSize, sizeof(DWORD));
		m_colorDataSize = htonl(m_colorDataSize);
		if(m_colorDataSize > 0)
			file.Seek(m_colorDataSize, CFile::current);

		//resoure data section
		file.Read(&m_resourceSize, sizeof(DWORD));
		m_resourceSize = htonl(m_resourceSize);
		if(m_resourceSize > 0)
			file.Seek(m_resourceSize, CFile::current);


		//layer data section
		file.Read(&m_layerDataSize, sizeof(DWORD));
		m_layerDataSize = htonl(m_layerDataSize);
		if(m_layerDataSize > 0)
			file.Seek(m_layerDataSize, CFile::current);

		file.Close();
		return TRUE;
	}
	return FALSE;
}
